
#import <appkit/appkit.h>

// Note: the daymisckit may be obtained via ftp from ftp.byu.edu
// (in /pub/next) or from Don Yacktman at Don_Yacktman@byu.edu
#import <daymisckit/daymisckit.h>


#define ALARM_FREQUENCY 10.0		// check the time once every ten seconds

// what type of alarm is it?
#define ALARM_SOUND 0
#define ALARM_GRAPHIC 1
#define ALARM_SOUND_AND_GRAPHIC 2
#define ALARM_UNIX_COMMAND 3


@interface AlarmClock:Object
{
    id	timeMatrix;
    id	typeList;
    id	animator;
    id	strings;
    id	unixWindow;
    id	soundText;
    id	imageText;
    id	unixText;
	int num;
	
	// times set by user in the panel
	DAYTime *fromSet;
	DAYTime *absolute;
	DAYTime *fromLaunch;
	DAYTime *launchTime;
	
	// actual absolute times that the alarms go off and info about how
	// the alarm should go off
	DAYTime *alarms[3];	// 0=set time, 1=from set, 2= from launch, all absolute
	NXImage *images[3];
	Sound *sounds[3];
	DAYString *commands[3];
	BOOL alarmOn[3];
	int alarmType[3];
}

- appDidInit:sender;
- setAlarm:sender;
- tick:sender;
- free;
- getSound:sender;
- getImage:sender;
- setSound:sender;
- setGraphic:sender;
- setSoundAndGraphic:sender;
- setUnixCommand:sender;
- gotUnixCommand:sender;
- doAtSetTime:sender;
- doFromNow:sender;
- doFromLaunch:sender;

@end
