//
// AnalogClock
//
// Module for BackSpace.app
// 7 Nov 91
// Matt Pharr- pharr@cs.yale.edu
//

#import <appkit/View.h>
#import "Thinker.h"

#define CLOCK_WIDTH 256
#define CLOCK_HEIGHT 256

@interface AnalogClockView:View
{
  NXPoint currentLocation;     // current location of the bitmap
  NXPoint moveVector;          // not a point, but a vector that describes how
                               // the bitmap is moving...
  int hours;
  int mins;
  int secs;
  int hasColor;                // 0 if a monochome machine, else 1
  NXSize currentSize;          // the size of the bitmap
  id currentImage;             // the bitmap itself that holds the drawing of 
                               // the time
  id hourMinuteImage;          // bitmap of the clock minus the second hand, so
                               // we only have to draw the whole clock once a
                               // minute, as opposed to once a second, as before
}

-oneStep;
-drawSelf:(const NXRect *)rects :(int)rectCount;
-initFrame:(const NXRect *)frameRect;
@end
