#import <objc/Object.h>
#import <streams/streams.h>

@interface YapDocument:Object {
  id outputView;
  id document;
  id bbTextField;
  id versionField;
  id computeBBSwitch;
  id gridEnableSwitch;
  id blueEnableSwitch;
  char *name;
}

+ new;
+ newFromFile:(const char *)fileName;
- initializePrintInfo;

// Connect to target/action methods

- save:sender;
- saveAs:sender;
- execute:sender;
- document;
- setBBoxField:(float)llx :(float)lly :(float)urx :(float)ury;
- print:sender;
- insertBB:sender;
- insertVersion:sender;
- insertBoth:sender;
- setComputeBB:sender;
- setMeshEnable:sender;
- setBlueEnable:sender;

// Other methods

- setName:(const char *)title;
- (const char *)name;
- (int)saveDocument:(const char *)fileName;

// The following delegate method is used for detecting when the user 
// edits the text.

- text:text isEmpty:(BOOL)empty;

// ...and the following when he/she changes the font.

- textWillConvert:textObject fromFont:oldFont toFont:newFont;
- windowDidResize:sender;

// delegate methons
- windowWillClose:sender action:(const char *)action;
- windowWillClose:sender;

// YapDocuments have their own zones; the following two methods allow
// reuse of zones.

+ (NXZone *)newZone;
+ (void)reuseZone:(NXZone *)aZone;

@end
