#import <appkit/View.h>

@interface YapOutput:View {
  id cache;      // Bitmap in which we cache the output of the PS program
  BOOL showCache;
  BOOL clearCache;
  BOOL meshON;
  BOOL blueON;
  BOOL blackBG;
  BOOL figureBB;
  id currentDocument;	// Stores id of current document.
			// This is to make Output window the first responder.
  NXRect region;	// drag specified BBox rectangle
  NXColor rubberBandColor;
}


- initFrame:(const NXRect *)viewFrame;
- setRubberBandColor:(NXColor)color;
- (BOOL)acceptsFirstResponder;
- mouseDown:(NXEvent *)event;
- dragSelect:(NXEvent *)event;
- scrollPointToVisible:(const NXPoint *)point;

- sizeTo:(NXCoord)width :(NXCoord)height;
- free;
// - executeCodeFrom:textObj;

- setCurrentDocument:anDoc;
- executeCodeFrom:document andReturnBB: (float *)llx : (float *)lly
				     : (float *)urx : (float *)ury
			  usertime: (int *) utime;

- drawSelf:(NXRect *)rects :(int)rectCount;

- (BOOL)isCacheCleared;
- (BOOL)isCacheShown;
- (BOOL)isMeshON;
- (BOOL)isBlueON;
- (BOOL)isFigureBB;
- setCacheCleared:(BOOL)flag;
- setCacheShown:(BOOL)flag;
- setMeshON:(BOOL)flag;
- setBlueON:(BOOL)flag;
- setFigureBB:(BOOL)flag;

@end




