/* Misc.h -- Various defines used in the program
   Copyright (C) 1992, 1993 David A. Strout

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

/* Written by David Strout <dstrout@isi.edu>. */



#define NUMSHIPS 8 /* Number of ships on each side */

#define RANDINT(n) (random() % ((n)+1))		/* Random integer 0..n */
#define ONEIN(n)   ((random() % (n)) == 0)	/* TRUE one in n times */
#define INITRAND   srandom(time(0))		/* Randomizer */

#define MAX_DAM 1000 /* Zero means destroyed */
#define FED_DAM 100 /* Damage a Federation shot does */
#define KLI_DAM 50 /* Damage a Klingon shot does */

#define SHOTS_PER_FRAME 1

#define NEW_HEAD 50 /* change direction one in NEW_HEAD frames */

#define FED 0
#define KLI 1

#define BORDER 8 /* in base co-ord units */

#define EXPLODE0 0
#define EXPLODE1 1
#define EXPLODE2 2
#define EXPLODE3 3
#define EXPLODE4 4
#define EXPLODE5 5
#define EXPLODE6 6
#define EXPLODE7 7
#define DEAD 8
#define OK 9

#define NORTH 0
#define NEAST 1
#define EAST 2
#define SEAST 3
#define SOUTH 4
#define SWEST 5
#define WEST 6
#define NWEST 7
