/* SpaceThing.h -- interface for SpaceThing objects
   Copyright (C) 1992, 1993 David A. Strout

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

/* Written by David Strout <dstrout@isi.edu>. */



#import <appkit/appkit.h>
#import <objc/Object.h>
#import "Misc.h"

@interface SpaceThing:Object
{
  NXPoint location, oldLoc;
  int heading; 
  int speed; /* In base co-ords / frame */
  int status;
  float maxX;
  float maxY;
}

- findImageNamed:(const char *)name;
- init;
- setViewXSize:(float)x YSize:(float)y;
- drawSelf;
- newVector;

- checkMove;
- oneStep;

- (float) xLoc;
- (float) yLoc;

@end

