//#import <appkit/appkit.h>
//#import <3Dkit/3Dkit.h>
#import <appkit/appkit.h>
#import <3Dkit/N3DCamera.h>
#import <3Dkit/N3DLight.h>
#import <3Dkit/N3DRotator.h>
#import <3Dkit/N3DShader.h>
#import <3Dkit/N3DShape.h>
#import "DN3DString.h"
#import "Thinker.h"

@interface CharenderView:N3DCamera
{
	DN3DString	*textShape;
	N3DShape	*textBox;
	N3DShader	*theShader;

	float dx, dy, dz;
	RtPoint rotationAxis;
	float theta;

	id	inspectorPanel;
	id	surfaceMatrix;
	id	colorWell;
	id	stringField;
	id	resolutionTextField;
	id	resolutionSlider;
	
//	Defaults
	char *textDefault;
	char *fontDefault;
	NXColor colorDefault;
	int surfaceTypeDefault;
	int resolutionDefault;

}

+ initialize;

- initFrame:(const NXRect *) theRect;
- oneStep;
- (BOOL) useBufferedWindow;
- (const char *)windowTitle;
- inspector:sender;
- setStringAndFontFrom:sender;
- setColorFrom:sender;
- setSurfaceTypeFrom:sender;
- setResolutionFrom:sender;
- getDefaults;

@end
