/* CNAppManager.h				 
 *
 * This is the basic controller of the App. It manages all hig abstraction
 * tasks for the panel, documents and connections to the outside.
 *
 * Usage: This is not a very reusable object. 
 *
 * Written by: 		Thomas Engel
 * Created:    		25.01.1995 (Copyleft)
 * Last modified: 	25.01.1995
 */

#import <appkit/appkit.h>

@interface CNAppManager:Object
{
	id	notesWindow;
	id	notesText;

	id	newPasteCountField;
	int	newPastes;

	// About the defaults.

	id	enableServicesSwitch;
	id	saveWithBackupSwitch;
	id	notesPathField;
	id	replaceSelectionSwitch;
	id	notesCreationModeSwitch;
	id	notesTemplateText;
	id	timeFormatField;
	id	dateFormatField;

	id	composeText;
	id	tempNoteText;
	id	tempPb;
	BOOL	_isEscaping;
	BOOL	_notesLoaded;
 BOOL _templateChanged;
 BOOL _firstActivation;
}

// Some methods need to get the app started..

- appWillInit:sender;
- appDidInit:sender;
- (int)app:sender openFile:(const char *)path type:(const char *)type;
- (BOOL)appAcceptsAnotherFile:sender;
- appDidBecomeActive:sender;
- appWillTerminate:sender;
- app:sender powerOffIn:(int)ms andSave:(int)aFlag;
- powerOff:(NXEvent *)theEvent;

// Here we do the handling of our Panels & Tools

- showInfo:sender;
- showPreferences:sender;
- preferences;

- openDefaults;
- saveDefaults;

// Here we have the methods the control our document. They work via the
// first responder chain.

- new:sender;
- open:sender;
- save:sender;
- revert:sender;

- print:sender;
- escape:sender;

// doing the work...

- copyNotesTemplate;
- pasteAsNote:sender;
- _pasteIt;

- note:(id)pb userData:(const char *)udata error:(char **)ermsg;

// To see all the changes...

- textDidChange:sender;

@end

/*
 * History: 13.01.95 Bla.
 *
 *
 * Hints: This Object could be defined as a subclass of a general docManager
 *		 like the one provided by the NeXT-miniexamples...Maybe later or never
 *
 *
 * Bugs: No bugs and birds seen....
 */