//
// Clock
//
// Module for BackSpace.app
// 3 Nov 91
// Matt Pharr- pharr@cs.yale.edu
//

#import <appkit/View.h>
#import "Thinker.h"

@interface ClockView:View
{
  NXPoint currentLocation;     // current location of the bitmap
  NXPoint moveVector;          // not a point, but a vector that describes how
                               // the bitmap is moving...
  char theTime[10];            // the current time, in string form "hh:mm:ss"
  char lastTime[10];           // the time the last time oneStep was called
  NXSize currentSize;          // the size of the bitmap
  id currentImage;             // the bitmap itself that holds the drawing of 
                               // the time
  id theFont;                  // font object for the font we're using
  float currGrey;              // sitting constant at .667...
  float currR, currG, currB;   // may be varying via calls to chooseColor
}

-oneStep;
-chooseColor;
-drawSelf:(const NXRect *)rects :(int)rectCount;
-init;
@end
