/*
 *    Filename:	compress.h 
 *    Created :	Mon Jul  1 16:14:59 1991 
 *    Author  :	Vince DeMarco
 *		<demarco@cpsc.ucalgary.ca>
 */


/* compress.c */

/* Return codes */
#define COMP_OKAY 	  0  /* everything is okay					 */
#define COMP_EXIST 	  1  /* file doesn't exist					 */
#define COMP_BIG	  2  /* if file size would expand if compressed			 */
#define COMP_Z		  3  /* file doesn't end with a .Z				 */
#define COMP_BITS	  4  /* compressed with different number of bits that i can handle */
#define COMP_ALREADY	  5  /* file already compressed 					 */
#define COMP_OUTPUT	  6  /* can't open output file					 */
#define COMP_NOTCOMP	  7  /* not in compressed format					 */
#define COMP_TOOLONG      8  /* pathname too long */
#define COMP_OUTEXISTS    9  /* output file already exits */
#define COMP_DIRUNREADABLE 10  /* input directory Unreadable */

#define UNCOMPRESS      1
#define COMPRESSS       0
#define FORCEOVERWRITE  1
#define NO_OVERWRITE    0
#define RECURSIVE       1
#define NOT_RECURSIVE   0

int compress_decompress(int do_decompression, 
			int force_overwrite, 
			int recursive_comp_decomp, 
			char *file_name);

