#import <appkit/appkit.h>

#define DOCKMGRVERSION 3

@interface DockMgrView : View
{
	id		theImage;
	id		appHash;
	id		appTileImage;
	id		dockList;
	id		currentDock;
	id		monsterSound;
	id		destroySound;
	id		dragView;
	id		dockNameCell;
	id		miniwindowStore;
	id		raiseButton;
	id		nextLevelButton;
	id		rbImage;
	id		rbAltImage;
	id		rbDImage;
	id		nbImage;
	id		nbAltImage;
	id		nbDImage;
	id		nbDAltImage;
	int		currentDockIndex;
	double	clickTime;
	BOOL	showDock;
	BOOL	acceptDrag;
	BOOL	dragChecked;
	BOOL	itemOnDock;
	BOOL	windowsNeedUpdate;
	NXPoint	mouseOffset;
	DPSTimedEntry timer;
}

- initFrame:(const NXRect *)aFrame withWindow:aWindow;
- mouseDown:(NXEvent *)event;
- drawSelf:(const NXRect *) rects:(int)rectCount;
- readDocks;
- writeDocks;
- setDragView:theView andOffset:(NXPoint *)offset;
- draggedImage:theImage endedAt:(NXPoint *)screenPoint deposited:(BOOL)didDeposit;
- setIconSize:(int)aValue;
- (int)iconSize;
- deleteView:theView;
- addLevel;
- deleteLevel;
- activateFiend:sender;
- setDockNameCellFont:(NXRect *)aRect;
- setShowDock:(BOOL)flag;
- (BOOL)showDock;
- rotateOffsets;
- gotoDockLevel:(int)aLevel;
- moveLevelTo:(int)aLevel;
- nextLevel;
- previousLevel;
- (int)currentDockIndex;
- currentDock;
- findLevelContaining:(const char *)aPath;
- windowDidMove:sender;
- clearDockLevel;
- copy:sender andCut:(BOOL)flag;
- paste:sender;

- app:theApp applicationWillLaunch:(const char *)theAppName;
- app:theApp applicationDidLaunch:(const char *)theAppName;
- app:theApp applicationDidTerminate:(const char *)theAppName;


@end
