#import <appkit/appkit.h>

@interface ShelfView : View 
{
    id		dragSourceView;
	id		droppedView;
    id		draggedView;
	int		gridValue;
	char	imageFileName[MAXPATHLEN-1];
    NXPoint	defaultLoc;
    NXColor	bgColor;
	NXImage	*theImage;
    BOOL	useBGColor;
	BOOL	tileImage;
    BOOL	gridEnabled;
    BOOL	keepSourceOnShelf;
}

- (void) createViewForPath:(const char *) path at:(NXPoint *) point;
- (void) removeViewForPath:(const char *) fullPath;

- mouseDown:(NXEvent *)e;
- deleteView:aView;
- deselectAll:sender;
- (char *)getImageFileName;
- setImageFileName:(const char *)theName;

- (NXDragOperation)draggingUpdated:(id <NXDraggingInfo>)sender;
- (NXDragOperation)draggingEntered:(id <NXDraggingInfo>)sender;
- draggingExited:(id <NXDraggingInfo>)sender;
- (BOOL)prepareForDragOperation:sender;
- (BOOL)performDragOperation:sender;
- concludeDragOperation:(id <NXDraggingInfo>)sender;
- draggedImage:(NXImage *)image beganAt:(NXPoint *)screenPoint;
- draggedImage:(NXImage *)image endedAt:(NXPoint *)screenPoint
     deposited:(BOOL)didDeposit;
- (NXDragOperation) draggingSourceOperationMaskForLocal:(BOOL)flag;
- (void)alignSubviews;
- setDragView:aView onEvent:(NXEvent *) e
		 withOffset:(NXPoint *) offset
		 atLocation:(const NXPoint *) location;

- (NXColor) backgroundColor;

- (int) gridValue;
- setGridValue:(int) gridValue;

- (void) setGridEnabled:(BOOL) flag;
- (BOOL) gridEnabled;

- setTileImage:(BOOL)flag;
- (BOOL)tileImage;

- (BOOL)hasSelectedCells;
- copy:sender andCut:(BOOL)flag;
- paste:sender;
- selectViewsInRect:(NXRect *)theRect deselect:(BOOL)flag;

- readShelf:(BOOL)showProgress;
- writeShelf;

@end


