/*
 *   This sourcecode is part of FileSpy, a logfile observing utility.
 *   Copyright (C) 1996  Felix Rauch
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *   
 *   Notice that this program may not be possessed, used, copied,
 *   distributed or modified by people having to do with nuclear
 *   weapons. See the file CONDITIONS for details.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *   To contact the original author, try:
 *   e-mail: Felix.Rauch@nice.ch
 *   Traditional mail:	Felix Rauch
 *			Sempacherstrasse 33
 *			8032 Zurich
 *			Switzerland
 */

#import "Controller.h"

@implementation Controller(Info)

- loadInfo
{
    if(!infoPanel) {
#ifdef DEBUG
	char tmpStr[strlen(versionString) + 1];
#endif
	if(![NXApp loadNibSection:"Info.nib" owner:self withNames:NO fromZone:[self zone]]) {
	    NXLogError("Can't find Info.nib!");
	}
#ifdef DEBUG
	strcpy(tmpStr, versionString);
	strcat(tmpStr, "D");
	[versionTextField setStringValue:tmpStr];
#else
	[versionTextField setStringValue:versionString];
#endif
    }
    return self;
}

- showInfo:sender	// loads and shows infopanel. if we're debuging, append "D" to version-number-string
{
    [self loadInfo];
    [infoPanel makeKeyAndOrderFront:sender];
    return self;
}

- showConditions:sender
{
    [self loadInfo];
    [conditionsWindow makeKeyAndOrderFront:sender];
    return self;
}

- showCopying:sender
{
    [self loadInfo];
    [copyingWindow makeKeyAndOrderFront:sender];
    return self;
}

- showHelp:sender
{
    [self loadInfo];
    [helpWindow makeKeyAndOrderFront:sender];
    return self;
}

@end
