#import <appkit/appkit.h>

@interface Fly:Object
{
	NXImage		*fly;
	NXImage		*guts;
	NXImage		*mask;
	Sound		*splat;
	NXPoint		pos;
	NXPoint		gutsPos;
	NXRect		cell;
	int			head;
	float		speed;
	long		statePeriod;
	long		noTurn;
	long		leftTurn;	
	BOOL		firstState;
	BOOL		isSplat;
}

- init;
- free;

- setFlyImage:(NXImage *)image;
- setGutsImage:(NXImage *)image;
- setMaskImage:(NXImage *)image;
- setSplatSnd:(Sound *)snd;

- setCellRect;
- setHeading:(long)h;
- setSpeedValue:(float)s;
- setPeriod:(long)period;
- setPosition:(NXPoint)p;
- setState:(BOOL)state;
- setNoTurn:(long)nt andLeftTurn:(long)lt;
- toggleSplat:(BOOL)splatted;
- (NXPoint *)position;
- (long)heading;
- (float)speed;
- (BOOL)isFirstState;
- (long)statePeriod;
- (long)noTurn;
- (long)leftTurn;
- (BOOL)isSplat;

- doSplat;

- drawFly;
- eraseFly;
- drawGuts;
- eraseGuts;

@end