#import <appkit/appkit.h>
#import "FlyCommon.h"
#import "Fly.h"
#import "FlyLogic.h"
#import "FlyFuncs.h"

NXDefaultsVector defs = {
	{"NumFlies",		"8"},
	{"FlySpeed",		"12"},
	{"AnimationSpeed",	"480"},
	{NULL,				NULL}
};

@interface FlyView:View
{
	id				flyList;
	id				flyWindow;
	Fly				*currentFly;
	NXBundle		*flyBundle;
	NXImage			*flyImage;
	NXImage			*gutsImage;
	NXImage			*maskImage;
	FlyLogic		*flyLogic;
	Sound			*splatSnd;
	const char		*moduleDir;
	port_t			*port;
	long			frameRate;
	unsigned int	flyCount;
	unsigned int	maxFlyCount;

	id				inspectorPanel;
	id				speedSlider;
	id				animationSlider;
	id				flyCountSlider;
	id				flyCountBox;
	id				infoText;
}

- initFrame:(NXRect *)frameRect;
- (Fly *)createFly;
- free;

- oneStep;
- drawSelf:(const NXRect *)rects :(int)rectCount;
- mouseDown:(NXEvent *)theEvent;

- newWindow;
- sizeTo:(NXCoord)width :(NXCoord)height;
- (const char *) windowTitle;

- inspector:sender;
- inspectorWillBeRemoved;

- setSpeed:sender;
- setFlySpeed:(Slider *)sender forFly:(Fly *)fly;
- setAnimationSpeed:sender;
- setNumFlies:sender;

- delayedDefaults:sender;
- getDefaults:sender;
- writeDefaults:sender;

@end
