//**************************************************************************
//	Copyright (c)1991-1993 KNOPS EDV-Anlagen Gerd Knops
//
//	Project	: GTools
//	File	: GTools
//	Author	: Gerd Knops
//	Date	: 930921
//
//**************************************************************************
#import <appkit/NXDataLinkManager.h>
//**************************************************************************
@interface GKAppDelegate:Object
{
	id		delegateList;	// The list of the delegates
}
//**************************************************************************
// factory methods
//**************************************************************************
- init;
//**************************************************************************
// Adding delegates
//**************************************************************************
- addDelegate:sender;
- removeDelegate:sender;
//**************************************************************************
// <PRIVATE>
// Methods, that should be subclassed
//**************************************************************************
- (GKClassLocation *)classLocations;
// <PUBLIC>
//**************************************************************************
// Application delegate methods, not forwarded to the delegates
//**************************************************************************
- appWillInit:sender;
//**************************************************************************
// Application delegate methods, used and forwarded to the delegates
//**************************************************************************
- appDidInit:sender;
- appWillTerminate:sender;
- app:sender powerOffIn:(int)ms andSave:(int)aFlag;
//**************************************************************************
// Application delegate methods, only forwarded to the delegates
//**************************************************************************
- app:sender applicationWillLaunch:(const char *)appName;
- app:sender applicationDidLaunch:(const char *)appName;
- app:sender applicationDidTerminate:(const char *)appName;
- app:sender fileOperationCompleted:(int)operation;
- app:sender mounted:(const char *)fullPath;
- (int)app:sender unmounting:(const char *)fullPath;
- app:sender unmounted:(const char *)fullPath;
- appDidBecomeActive:sender;
- appDidResignActive:sender;
- appDidHide:sender;
- appDidUnhide:sender;
- appWillUpdate:sender;
- appDidUpdate:sender;
- applicationDefined:(NXEvent *)theEvent;
- app:sender willShowHelpPanel:panel;
- (int)app:sender
		openFile:(const char *)filename 
		type:(const char *)aType;
- (BOOL)appAcceptsAnotherFile:sender;
- (int)app:sender
		openTempFile:(const char *)filename 
		type:(const char *)aType;
- (NXDataLinkManager *)app:sender
		openFileWithoutUI:(const char *)filename 
		type:(const char *)type;
//**************************************************************************
// <PRIVATE>
// private methods
//**************************************************************************
- famousLastWords:(BOOL)canContinue;
- (BOOL)validateCommand:menuCell;
//**************************************************************************
// <PUBLIC>
// Internal methods
//**************************************************************************
- (BOOL)menuItemUpdate:menuCell;
@end
//***********************************************************************EOF