//**************************************************************************
//	Copyright (c)1993 KNOPS EDV-Anlagen Gerd Knops
//
//	Project	: GKLibrary
//	File	: GKLocalizer
//	Author	: Gerd Knops
//	Date	: 931121
//
//**************************************************************************
//**************************************************************************
// Defines
//**************************************************************************
	#define GKLocalString(theString) [[[self module]localStrings]valueFor:theString]
//**************************************************************************
@interface Window(GKLocalizer)
//**************************************************************************
- localizeWith:theTable;
@end
// <PRIVATE>
//**************************************************************************
@interface View(GKLocalizer)
//**************************************************************************
- localizeWith:theTable;
@end
//**************************************************************************
@interface Box(GKLocalizer)
//**************************************************************************
- localizeWith:theTable;
@end
//**************************************************************************
@interface Control(GKLocalizer)
//**************************************************************************
- localizeWith:theTable;
@end
//**************************************************************************
@interface Cell(GKLocalizer)
//**************************************************************************
- localizeWith:theTable;
@end
//**************************************************************************
@interface Matrix(GKLocalizer)
//**************************************************************************
- localizeWith:theTable;
@end
//**************************************************************************
@interface NXBrowser(GKLocalizer)
//**************************************************************************
- localizeWith:theTable;
@end
//**************************************************************************
@interface Menu(GKLocalizer)
//**************************************************************************
- localizeWith:theTable;
- localizeWith:theTable path:(const char *)path;
@end
//**************************************************************************
// <PUBLIC>
@interface GKLocalizedStringTable:NXStringTable
{
	char	*name;			// The name of the stringtable
	id		owner;			// The owner of the stringtable
	id		newStrings;		// A NXStringTable instance, that keeps track
							// of newly added keys.
}
//**************************************************************************
// Class methods
//**************************************************************************
+ initialize;
+ appWillTerminate:theApp;
+ tableNamed:(const char *)theName owner:theOwner;
//**************************************************************************
// Factory methods
//**************************************************************************
- initWithName:(const char *)theName owner:theOwner;
//**************************************************************************
// Implementation methods
//**************************************************************************
- (const char *)name;
- (const char *)valueFor:(const char *)key;
- (const char *)valueIfKey:(const char *)key;
- addKey:(const char *)theKey;
//**************************************************************************
// Archiving related methods
//**************************************************************************
- read;
- write;
@end
// <PRIVATE>
//**************************************************************************
@interface Object(GKLocalizer)
//**************************************************************************
- localize:target;
@end
//***********************************************************************EOF