//**************************************************************************
//	Copyright (c)1993 KNOPS EDV-Anlagen Gerd Knops
//
//	Project	: GKLibrary
//	File	: GKModuleController
//	Author	: Gerd Knops
//	Date	: 931120
//
//**************************************************************************
// <PRIVATE>
//**************************************************************************
// Types
//**************************************************************************
typedef struct
{
	const char	*rPath;		// Path relative to mainBundle
	const char	*ext;		// Extension without dot
}
GKClassLocation;
//**************************************************************************
@interface GKModuleController:Object
{
	id		moduleList;
	id		refClassesList;
	id		refModulesList;
}
//**************************************************************************
// Class methods
//**************************************************************************
+ new;
+ addObjectReference:object:module;
+ findModuleForObject:object;
//**************************************************************************
// Factory methods
//**************************************************************************
- init;
- initFromConfig;
- initByParsing;
- parseModulesIn:(const char *)thePath;
- readConfigFromFile:(const char *)theFile;
- writeConfigToFile:(const char *)theFile;
//**************************************************************************
// Services related Methods
//**************************************************************************
- checkServices;
//**************************************************************************
// Misc methods
//**************************************************************************
- moduleNamed:(const char *)name;
- moduleFor:theObject;
- classLoadError:(const char *)className;
- appModule;
- moduleList;
- (BOOL)debug;
//**************************************************************************
// Load methods
//**************************************************************************
- loadClass:(const char *)theClassName;
@end
// <PUBLIC>
//****************************************************************************
@interface Object(GKModuleController)
//****************************************************************************
// new methods
//****************************************************************************
+ module;
- module;
@end
//***********************************************************************EOF