//**************************************************************************
//	Copyright (c)1993 KNOPS EDV-Anlagen Gerd Knops
//
//	Project	: GKLibrary
//	File	: GKValidater
//	Author	: Gerd Knops
//	Date	: 931127
//
//**************************************************************************
@interface GKValidater:Object
{
	// <PRIVATE>
	unsigned long	operational[256];
	unsigned long	timed[256];
	unsigned long	*timedTimes;
	// <PUBLIC>
}
//**************************************************************************
// class methods
//**************************************************************************
+ (const char *)codeStringForModule:principalClass;
+ (BOOL)doLicensationWith:(const char *)keyString;
+ (BOOL)moduleIsOperational:principalClass;
+ (unsigned short)expirationDateForModule:principalClass;
//**************************************************************************
// <PRIVATE> section
//**************************************************************************
+ new;
//**************************************************************************
// factory methods
//**************************************************************************
- init;
//**************************************************************************
// frontends for class methods
//**************************************************************************
- (const char *)codeStringForModule:principalClass;
- (BOOL)doLicensationWith:(const char *)keyString;
- (BOOL)moduleIsOperational:principalClass;
- (unsigned short)expirationDateForModule:principalClass;
//**************************************************************************
// other methods
//**************************************************************************
- (unsigned long)validationFor:(int)company;
- (unsigned long)timedFor:(int)company;
//**************************************************************************
// handling of licensation values and defaults
//**************************************************************************
- readLicensesFor:(int)company;
- addToLicensation:(unsigned long)freeCode:(unsigned long)dateID;
- (unsigned short)curTime;
//**************************************************************************
// coding methods
//**************************************************************************
- encode:(const char *)codeBits to:(char *)theCode
	withKey:(const char *)encodeKey;
- (BOOL)decode:(const char *)theCode to:(char *)codeBits
	withKey:(const char *)decodeKey;
//**************************************************************************
// coding sub methods
//**************************************************************************
- (short)codeSection:(int)pos of:(const char *)what;
- (short)getBit:(int)pos inString:(const char *)what;
- (int)getCodeByte:(int)num of:(const char *)theCode;
- (int)getCodeBit:(int)bitNum of:(const char *)theCode;
//**************************************************************************
// coding utility methods
//**************************************************************************
- makeEncodeString:(char *)encodeString fromTemplate:(const char *)template;
//**************************************************************************
// utility methods
//**************************************************************************
- (unsigned long)gethostid;
- (unsigned long)productID;
- writeLong:(unsigned long)val toPos:(char *)pos;
- (unsigned long)readLongFromPos:(char *)pos;
- writeShort:(unsigned short)val toPos:(char *)pos;
- (unsigned short)readShortFromPos:(char *)pos;
@end
//***********************************************************************EOF