/*
 *  Copyright (C) 1993  Robert Davis
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of Version 2, or any later version, of 
 *  the GNU General Public License as published by the Free Software 
 *  Foundation.
 */

/* $Id: AxesPane.h,v 1.7 1993/05/04 16:21:14 davis Exp $ */

#import "Pane.h"

@class TicOptionsPanel;

@interface AxesPane:Pane
{
    TicOptionsPanel *ticOptionsPanel;

    BOOL	didSwap;	/* True if we just became the current pane */

    id		axisXButton;
    id		axisYButton;
    id		axisTitleField;
    id		gridButton;
    id		labelMatrix;
    id		labelMatrixLabelMatrix;
    id		rangeAutoMatrix;
    id		rangeMatrix;
    id		anglesButton;
    int		oldAnglesTag;
    id		ticsMatrix;
    id		ticsInMatrix;

    id		logMatrix;
}

- init;
- free;

- selectControl:sender;			/* Overridden from Pane */
- (BOOL)updateStatus:aStatus doc:aDoc;
- didSwapIn:sender;

- doSetRangeAuto:sender;		/* Target/Action	*/
- doSetRange:sender;
- doSetLog:sender;
- doSetAngles:sender;
- doSetLabel:sender;
- doSetTics:sender;
- doSetAxis:sender;
- doSetGrid:sender;
- doSetTicsIn:sender;

- showTicOptionsPanel:sender;

/*  Window delegate methods */
- windowDidUpdate:sender;

@end
