/*
 *  Copyright (C) 1993  Robert Davis
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of Version 2, or any later version, of 
 *  the GNU General Public License as published by the Free Software 
 *  Foundation.
 */


/* $Id: DoubleValueSortedList.h,v 1.5 1993/05/04 16:21:44 davis Exp $ */

#import <objc/List.h>

#define	NO_MAX	-1

@interface DoubleValueSortedList:List
{
    BOOL	isAscending;	/* YES = Ascending, NO = Descending	    */
    int		absoluteMax;	/* Can't have more elements than this	    */
}

- init;

- setAscending:(BOOL)aBool;
- (BOOL)isAscending;

- setMax:(int)anInt;
- (int)max;

- (int)addObject:anObject;
- (int)addObjectIfDoubleAbsent:anObject;


/** Overridden to do nothing **/

- insertObject:anObject at:(unsigned)index;
- replaceObjectAt:(unsigned) index with:newObject;


/** Private Methods **/

- _reorderObjects;

@end
