/*
 *  Copyright (C) 1993  Robert Davis
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of Version 2, or any later version, of 
 *  the GNU General Public License as published by the Free Software 
 *  Foundation.
 */

/* $Id: FunctionObject.h,v 1.6 1993/05/24 03:59:43 davis Exp $ */

#import "SubObject.h"

#define FUNCTION_NOSTYLE	99
#define	FUNCTION_LINES		0
#define FUNCTION_POINTS		1
#define FUNCTION_LINESPOINTS	2
#define FUNCTION_DOTS		3
#define FUNCTION_IMPULSES	4
#define FUNCTION_ERRORBARS	5
#define FUNCTION_BOXES		6
#define FUNCTION_BOXERRORBARS	7
#define FUNCTION_STEPS		8

#define POINTS_NOSTYLE		0
#define LINE_NOSTYLE		0

#define	NO_COLUMN		-1	/* For data files */

struct coldat {
    BOOL	isOn;
    int		number;			/* Number of columns */
    int		x, y, yDelta, yLow, yHigh, z, boxWidth;
    BOOL	useX, useY, useYDelta, useYLow, useYHigh, useZ, useBoxWidth;
};

@interface FunctionObject:SubObject
{
    BOOL	isDataFile;	/* Is stringValue path of a data file?	*/
    BOOL	isThreeD;	/* Is this supposed to be plotted in 3	*/
    char	*title;		/* Optional key title			*/
    int		style;		/* Optional style			*/
    int		pointsStyle;	/* Kind of points (if style has points)	*/
    int		lineStyle;	/* Kind of line (if style has points)	*/

    struct coldat columnData;	/* How to interpret data file columns	*/
    struct coldat columnDataOther;
}

+ (BOOL) isAcceptableStringValue:(const char *)aString;
+ (BOOL) isAcceptableDataFile:(const char *)aString;

- initFromString:(const char *)aString isThreeD:(BOOL)aCond;
- free;

- setThreeD:(BOOL)cond;
- (BOOL)isDataFile;
- (struct coldat *)columnData;

- setTitle: (const char *)aString;
- (const char *)title;

- setStyle: (int)anInt;
- (int)style;
- (const char *)styleString;

- setPointsStyle: (int)anInt;
- (int)pointsStyle;

- setLineStyle: (int)anInt;
- (int)lineStyle;

- (BOOL)isAttachment;

@end
