/*
 *  Copyright (C) 1993  Robert Davis
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of Version 2, or any later version, of 
 *  the GNU General Public License as published by the Free Software 
 *  Foundation.
 */


/* $Id: ThreeDPane.h,v 1.4 1993/05/04 16:23:01 davis Exp $ */

#import "Pane.h"

@interface ThreeDPane:Pane
{
    BOOL didSwap;
    id	threeDButton;

    id	surfaceTypeMatrix;

    id	isoSamplesMatrix;
    id	isoSamplesLabel;

    id  rotXSlider;
    id  rotZSlider;
    id	rotMatrix;
    id	rotationResetButton;

    id	contourOptionsPanel;
    id	contourBaseButton;
    id	contourSurfaceButton;
    id	contourOptionsButton;
}


- init;
- free;

- selectControl:sender;			/** Overridden from Pane	**/
- (BOOL)updateStatus:aStatus doc:aDoc;
- (BOOL)forceUpdateStatus:aStatus doc:aDoc;


- doSetThreeD:sender;
- doSetSurfaceType:sender;
- doSetIsoSamples:sender;
- doSetRotation:sender;
- doResetRotation:sender;
- doSetContourBase:sender;
- doSetContourSurface:sender;

- showContourOptionsPanel:sender;	/** Contour Options Panel	**/

@end
