// Disks.m
//
// History :
//		10.09.1992 : created by Max Tardiveau

#import "Disks.h"

@implementation Disks



////////////////////////////////////////////////////////////////
// 

- fillList:theMatrix fromCell:theCell
{
FILE			*theFile;
struct mntent 	*theEntry;
int				cellCount;
id				newCell;
char			tmpChar[15];

if ([theCell updater])		// It's a disk
	{
	[self fillSubList:theMatrix ofCell:theCell pointer:(void *)0
												string:[theCell freeString]];
	return self;
	}

theFile = (FILE *)setmntent(MOUNTED,"r");
while (theEntry = getmntent(theFile))
	{
	if ( ! strncmp(theEntry->mnt_type, "nfs", 3))
		continue;
	[theMatrix addRow];
	cellCount = [theMatrix cellCount];
	newCell = [theMatrix cellAt:(cellCount - 1) :0];
	[newCell setStringValue:theEntry->mnt_fsname];
	strncpy(tmpChar, theEntry->mnt_fsname, 14);
	tmpChar[10] = '\0';
	tmpChar[9] = tmpChar[8];
	tmpChar[8] = tmpChar[7];
	tmpChar[7] = tmpChar[6];
	tmpChar[6] = tmpChar[5];
	tmpChar[5] = 'r';
	[newCell setFreeString:tmpChar];
	[newCell setUpdater:self];
	[newCell setDir:[theCell getDir]];
	[newCell setLeaf:NO];
	}

endmntent(theFile);

[theCell setMasterInstance:self];


return self;
}

////////////////////////////////////////////////////////////////
//

- doUpdateForCell:theCell
{
FILE			*theFile;
struct mntent 	*theEntry;
struct statfs	theStat;

theFile = (FILE *)setmntent(MOUNTED,"r");
while (theEntry = getmntent(theFile))
	{
	if ( strcmp(theEntry->mnt_fsname, [theCell stringValue]))
		continue;
	[FSname setStringValue:theEntry->mnt_fsname];
	[mountPoint setStringValue:theEntry->mnt_dir];
	[FStype setStringValue:theEntry->mnt_type];
	[FSoptions setStringValue:theEntry->mnt_opts];
	[dumpFrequency setIntValue:theEntry->mnt_freq];
	[FSCKpass setIntValue:theEntry->mnt_passno];
	break;
	}

endmntent(theFile);

if ( ! statfs(theEntry->mnt_dir, &theStat))
	{
	[blockSize setIntValue:theStat.f_bsize];
	[totalBlocks setIntValue:theStat.f_blocks];
	[totalBlocksMB setFloatValue:
			theStat.f_blocks * theStat.f_bsize / (1024. * 1024)];
	[freeBlocks setIntValue:theStat.f_bfree];
	[freeBlocksMB setFloatValue:
			theStat.f_bfree * theStat.f_bsize / (1024. * 1024)];
	[availBlocks setIntValue:theStat.f_bavail];
	[availBlocksMB setFloatValue:
			theStat.f_bavail * theStat.f_bsize / (1024. * 1024)];
	[fileNodes setIntValue:theStat.f_files];
	[freeFileNodes setIntValue:theStat.f_ffree];
	[ID1 setIntValue:theStat.f_fsid.val[0]];
	[ID2 setIntValue:theStat.f_fsid.val[1]];
	}
else
	{
	[blockSize setStringValue:"Error"];
	[totalBlocks setStringValue:"Error"];
	[totalBlocksMB setStringValue:"Error"];
	[freeBlocks setStringValue:"Error"];
	[freeBlocksMB setStringValue:"Error"];
	[availBlocks setStringValue:"Error"];
	[availBlocksMB setStringValue:"Error"];
	[fileNodes setStringValue:"Error"];
	[freeFileNodes setStringValue:"Error"];
	[ID1 setStringValue:"Error"];
	[ID2 setStringValue:"Error"];
	}

return self;
}

@end
