// DiskLabel.m
//

#import "DiskLabel.h"

@implementation DiskLabel


////////////////////////////////////////////////////////////////
//

- doUpdateForCell:theCell
{
int					theDevice;
struct disk_label	theLabel;
struct drive_info	theInfo;
char				tmpChar[10];
int					i;

theDevice = open([theCell freeString], O_RDONLY, 0);
if (theDevice == 0)
	{
	//fprintf(stderr, "DiskLabel : error in open().\n");
	[MyMaster addMessage:"DiskLabel : error in open().\n"];
	[Version setStringValue:"Error"];
	[BlockOfLabel setStringValue:"Error"];
	[SizeOfMediaArea setStringValue:"Error"];
	[MediaLabel setStringValue:"Error"];
	[Uninitialized setState:0];
	[VolumeTag setStringValue:"Error"];
	return self;
	}

if (ioctl(theDevice, DKIOCGLABEL, &theLabel) == -1)
	{
	//fprintf(stderr, "DiskLabel : error in ioctl(1).\n");
	[MyMaster addMessage:"DiskLabel : error in ioctl(1).\n"];
	[Version setStringValue:"Error"];
	[BlockOfLabel setStringValue:"Error"];
	[SizeOfMediaArea setStringValue:"Error"];
	[MediaLabel setStringValue:"Error"];
	[Uninitialized setState:0];
	[VolumeTag setStringValue:"Error"];
	close(theDevice);
	return self;
	}

strncpy(tmpChar, (char *)&theLabel.dl_version, 4);
tmpChar[4] = '\0';
[Version setStringValue:tmpChar];
[BlockOfLabel setIntValue:theLabel.dl_label_blkno];
[SizeOfMediaArea setIntValue:theLabel.dl_size];
[MediaLabel setStringValue:theLabel.dl_label];
[Uninitialized setState:(theLabel.dl_flags & DL_UNINIT)];
[VolumeTag setIntValue:theLabel.dl_tag];

if (ioctl(theDevice, DKIOCINFO, &theInfo) == -1)
	{
	//fprintf(stderr, "DiskLabel : error in ioctl(2).\n");
	[MyMaster addMessage:"DiskLabel : error in ioctl(2).\n"];
	for (i = 0; i < 4; i++)
		[[LabelLocMatrix cellAt:i :0] setStringValue:"error"];
	[SectorSize setStringValue:"Error"];
	[MaxBytes setStringValue:"Error"];
	[DriveType setStringValue:"Error"];
	close(theDevice);
	return self;
	}

for (i = 0; i < 4; i++)
	[[LabelLocMatrix cellAt:i :0] setIntValue:theInfo.di_label_blkno[i]];
[SectorSize setIntValue:theInfo.di_devblklen];
[MaxBytes setIntValue:theInfo.di_maxbcount];
[DriveType setStringValue:theInfo.di_name];

close(theDevice);

return self;
}


@end
