// KernServerPorts.m
//
// History :
//		10.24.1992 : created by Max Tardiveau

#import "KernServerPorts.h"


@implementation KernServerPorts


////////////////////////////////////////////////////////////////
// 

- fillList:theMatrix fromCell:theCell
{
int							i, cellCount;
id							newCell;
kern_return_t				result;
port_t						loader_port;
server_state_t				server_state;
vm_address_t				load_addr;
vm_size_t					load_size;
server_reloc_t				relocatable, loadable;
port_name_array_t			port_list;
unsigned int				count;
port_name_string_array_t	port_names;
boolean_array_t				advertisedArray;
task_t						kernel_port;

result = kern_loader_look_up(&loader_port);
if (result != KERN_SUCCESS)
	{
	[MyMaster addMessage:"KernServerPorts: error in kern_loader_look_up.\n"];
    return self;
	}

// Get kernel task port
result=task_by_unix_pid(task_self(), 0, &kernel_port);
if (result != KERN_SUCCESS)
	{
	[MyMaster addMessage:"KernServerPorts : error in task_by_unix_pid.\n"];
    return self;
	}
	
result= kern_loader_server_info(loader_port, kernel_port, [theCell freeString], 
	&server_state, &load_addr, &load_size, relocatable, loadable, &port_list, 
	&count, &port_names, &count, &advertisedArray, &count);
if (result != KERN_SUCCESS)
	{
	[MyMaster addMessage:
					"KernServerPorts : error in kern_loader_server_info.\n"];
    return self;
	}

for (i = 0; i < count; i++)
	{
	[theMatrix addRow];
	cellCount = [theMatrix cellCount];
	newCell = [theMatrix cellAt:(cellCount - 1) :0];
	[newCell setStringValue:port_names[i]];
	[newCell setFreeString:[theCell freeString]];
	[newCell setFreePointer:(void *)i];	// Assume always same order...
	[newCell setUpdater:self];
	[newCell setDir:[theCell getDir]];
	[newCell setLeaf:YES];
	}

[theCell setMasterInstance:self];

return self;
}

////////////////////////////////////////////////////////////////
//

- doUpdateForCell:theCell
{
kern_return_t				result;
port_t						loader_port;
server_state_t				server_state;
vm_address_t				load_addr;
vm_size_t					load_size;
server_reloc_t				relocatable, loadable;
port_name_array_t			port_list;
unsigned int				count;
port_name_string_array_t	port_names;
boolean_array_t				advertisedArray;
task_t						kernel_port;
int							i;

result = kern_loader_look_up(&loader_port);
if (result != KERN_SUCCESS)
	{
	[MyMaster addMessage:
					"KernServerPorts : error in kern_loader_look_up (2).\n"];
    return self;
	}

result=task_by_unix_pid(task_self(), 0, &kernel_port);
if (result != KERN_SUCCESS)
	{
	[MyMaster addMessage:"KernServerPorts : error in task_by_unix_pid (2).\n"];
    return self;
	}
	
result= kern_loader_server_info(loader_port, kernel_port, [theCell freeString], 
	&server_state, &load_addr, &load_size, relocatable, loadable, &port_list, 
	&count, &port_names, &count, &advertisedArray, &count);
if (result != KERN_SUCCESS)
	{
	[MyMaster addMessage:
				"KernServerPorts : error in kern_loader_server_info (2).\n"];
    return self;
	}

[serverName setStringValue:[theCell freeString]];
i = (int)[theCell freePointer];
[portName setStringValue:port_names[i]];
[advertised setState:advertisedArray[i]];

return self;
}


@end
