// NetRouteStats.m
//

#import "NetRouteStats.h"

@implementation NetRouteStats


#define VMUNIX "/mach"
#define KMEM "/dev/kmem"

////////////////////////////////////////////////////////////////
// Get a value out of kernel memory.
// offset is the byte offset into the kernel,
// ptr points to a buffer into which the value is put,
// size is the size of the buffer (and of the object to get).

static void getkval(int kfile, unsigned long offset, int size, void *ptr)
{
if (lseek(kfile, (long)offset, 0) == -1)
	{
	fprintf(stderr, "NetRouteStats : getkval : lseek error for %x\n", offset);
	exit(1);
	}

if (read(kfile, (char *)ptr, size) == -1)
	{
	fprintf(stderr, "NetRouteStats : getkval : read error at %x\n", offset);
	exit(1);
	}
}

////////////////////////////////////////////////////////////////
//

- doUpdateForCell:theCell
{
int 					kmem_file;
struct nlist			corelist[2];
struct	rtstat			RouteStat;

[theCell setUpdater:self];

if ((kmem_file = open(KMEM, 0)) < 0)
	{
	[MyMaster addMessage:"NetRouteStats : error opening KMEM.\n"];;
	return self;
	}

corelist[0].n_un.n_name = "_rtstat";
corelist[1].n_un.n_name = 0;

nlist(VMUNIX, corelist);
if  ((corelist[0].n_type == 0) && (corelist[0].n_value == 0))
	{
	[MyMaster addMessage:"NetRouteStats : error in nlist(2).\n"];
	close(kmem_file);
	return self;
	}

getkval(kmem_file, corelist[0].n_value, sizeof(struct rtstat), &RouteStat);

[badRedir setIntValue:RouteStat.rts_badredirect];
[dynamic setIntValue:RouteStat.rts_dynamic];
[newGateways setIntValue:RouteStat.rts_newgateway];
[unreach setIntValue:RouteStat.rts_unreach];
[wildcard setIntValue:RouteStat.rts_wildcard];

if (close(kmem_file) < 0)
	[MyMaster addMessage:"NetRouteStats : error closing kmem_file (2).\n"];

return self;
}

////////////////////////////////////////////////////////////////
//

- (int) updateInterval
{
return 20;
}

@end
