#import <stdio.h>
#import <sys/user.h>
#import <nlist.h>
#import <sys/proc.h>

#define VMUNIX "/mach"
#define KMEM "/dev/kmem"

////////////////////////////////////////////////////////////////
// Get a value out of kernel memory.
// offset is the byte offset into the kernel,
// ptr points to a buffer into which the value is put,
// size is the size of the buffer (and of the object to get).

static void getkval(int kfile, unsigned long offset, int size, void *ptr)
{
if (lseek(kfile, (long)offset, 0) == -1)
	{
	fprintf(stderr, "Processes : getkval : lseek error for %x\n", offset);
	exit(1);
	}

if (read(kfile, (char *)ptr, size) == -1)
	{
	fprintf(stderr, "Processes : getkval : read error at %x\n", offset);
	exit(1);
	}
}

////////////////////////////////////////////////////////////////

#define BUFFER_SIZE (16*9)

main()
{
int 			kmem_file;
struct nlist	corelist[2];
struct proc		*proc;
struct proc		tmpProcess;
unsigned char			buffer[BUFFER_SIZE];
int				i, j;

/////// Get list of processes
if ((kmem_file = open(KMEM, 0)) < 0)
	{
	fprintf(stderr, "Processes : error opening KMEM.\n");
	exit(1);
	}

corelist[0].n_un.n_name = "_allproc";
corelist[1].n_un.n_name = 0;

nlist(VMUNIX, corelist);
if  ((corelist[0].n_type == 0) && (corelist[0].n_value == 0))
	{
	fprintf(stderr, "Processes : error in nlist().\n");
	exit(1);
	}

getkval(kmem_file, corelist[0].n_value, sizeof(struct proc *), &proc);
getkval(kmem_file, (int)proc, sizeof(struct proc), &tmpProcess);

for (;;)		// This assumes there is at least one process (!)
	{
	getkval(kmem_file, (int)tmpProcess.task,
								BUFFER_SIZE, &buffer);
	
	for (i = 0; i < BUFFER_SIZE; i += 16)
		{
		printf("%4.4d : ", i);
		for (j = 0; j < 16; j++)
			printf("%2.2x ", buffer[i + j]);
		printf("\n");
		}
	
	printf("----------------------------------------\n");
	
	if ( ! tmpProcess.p_nxt)
		break;
	getkval(kmem_file, (int)tmpProcess.p_nxt,
									sizeof(struct proc), &tmpProcess);
	}

if (close(kmem_file) < 0)
	fprintf(stderr, "Processes : error closing kmem_file.\n");

}
