// ProcSetGraphs.m
//

#import "ProcSetGraphs.h"

@implementation ProcSetGraphs


////////////////////////////////////////////////////////////////
//

- doUpdateForCell:theCell
{
kern_return_t		error;
unsigned int		info_count;
struct processor_set_basic_info		basicInfo;
host_t				host;

[theCell setUpdater:self];

if ( ! running)
	{
	[graph0 initMin:0 max:0 title:"Number of tasks" numFormat:"%.0f"];
	[graph1 initMin:0 max:0 title:"Number of threads" numFormat:"%.0f"];
	[graph2 initMin:0 max:0 title:"Load average" numFormat:"%.1f"];
	[graph3 initMin:0 max:0 title:"Mach factor" numFormat:"%.3f"];
	running = YES;
	}

info_count = PROCESSOR_SET_BASIC_INFO_COUNT;

error = processor_set_info((processor_set_t)[theCell freePointer], 
				PROCESSOR_SET_BASIC_INFO, &host,
				(processor_set_info_t)&basicInfo, &info_count);
				
if (error != KERN_SUCCESS)
	{
	[MyMaster addMessage:"ProcSetGraphs : error in processor_set_info().\n"];
	return self;
	}

[graph0 addPoint:basicInfo.task_count];
[graph1 addPoint:basicInfo.thread_count];
[graph2 addPoint:((float)basicInfo.load_average/LOAD_SCALE)];
[graph3 addPoint:((float)basicInfo.mach_factor/LOAD_SCALE)];

return self;
}

////////////////////////////////////////////////////////////////
//

- (int) updateInterval
{
return 3;
}

@end
