// TaskGraphs.m
//

#import "TaskGraphs.h"

@implementation TaskGraphs


////////////////////////////////////////////////////////////////
//

- doUpdateForCell:theCell
{
kern_return_t			error;
struct task_basic_info	info;
unsigned int			info_count=TASK_BASIC_INFO_COUNT;

[theCell setUpdater:self];

if ( ! running)
	{
	[VMgraph initMin:0 max:0 title:"VM allocated" numFormat:"%.3f"];
	[residentGraph initMin:0 max:0 title:"Resident memory" numFormat:"%.3f"];
	running = YES;
	}

error = task_info((task_t) [theCell freePointer], TASK_BASIC_INFO, 
										(task_info_t)&info, &info_count);
if (error != KERN_SUCCESS)
	{
	[MyMaster addMessage:"TaskGraphs : error in task_info()\n"];
	return self;
	}

[VMgraph addPoint:info.virtual_size/(1024.0 * 1024.0)];
[residentGraph addPoint:info.resident_size/(1024.0 * 1024.0)];

return self;
}

////////////////////////////////////////////////////////////////
//

- (int) updateInterval
{
return 3;
}

@end
