// BootServices.m
//
// History :
//		10.20.1992 : created by Max Tardiveau

#import "BootServices.h"


@implementation BootServices


////////////////////////////////////////////////////////////////
//

- init
{
[super init];

myFont = [Font newFont:"Ohlfs"  size:11.0];

return self;
}

////////////////////////////////////////////////////////////////
//

- doUpdateForCell:theCell
{
[serviceBrowser loadColumnZero];

return self;
}

////////////////////////////////////////////////////////////////////////////////
// Browser methods

- cellClicked:sender
{
id			CurrentCell;

CurrentCell = [[serviceBrowser matrixInColumn:
								[serviceBrowser selectedColumn]] selectedCell];
// Do something here (what ?)

return self;
}

////////////////////////////////////////////////////////////////
//

- (int)browser:sender fillMatrix:matrix inColumn:(int)column
{
extern port_t  bootstrap_port;
id				newCell;
kern_return_t	result;
name_array_t	service_names, server_names;
bool_array_t	service_active;
unsigned int 	service_cnt, server_cnt, service_active_cnt;
char			tmpChar[128];
int				i, cellCount;

result = bootstrap_info(bootstrap_port, &service_names, &service_cnt,
			&server_names, &server_cnt, &service_active, &service_active_cnt);
if (result != BOOTSTRAP_SUCCESS)
    [MyMaster addMessage:"BootServices : error in bootstrap_info\n"];
else
	for (i = 0; i < service_cnt; i++)
		{
		[matrix addRow];
		cellCount = [matrix cellCount];
		newCell = [matrix cellAt:([matrix cellCount] -1) :0];
		[newCell setLeaf:YES];
		[newCell setFont:myFont];
		sprintf(tmpChar, "%-20.20s  |  %-25.25s  |  %-4.4s",
			service_names[i],
			server_names[i][0] == '\0' ? "Unknown" : server_names[i],
			service_active[i] ? "Yes\n" : "No\n");
			
		[newCell setStringValue:tmpChar];
		}

return [matrix cellCount];
}

@end
