// KernelInfo.m
//

#import "KernelInfo.h"

@implementation KernelInfo


////////////////////////////////////////////////////////////////
//

- doUpdateForCell:theCell
{
kern_return_t           ret;
kernel_version_t		theVersion;
struct host_basic_info  basic_info;
struct host_sched_info  sched_info;
unsigned int            count=HOST_BASIC_INFO_COUNT;
unsigned int            sched_count=HOST_SCHED_INFO_COUNT;

ret = host_kernel_version(host_self(), theVersion);
if (ret != KERN_SUCCESS)
	{
    fprintf(stderr, "KernelInfo : Error calling host_kernel_version().\n");
	[[versionString docView] setText:"Error"];
	}
else
	[[versionString docView] setText:theVersion];

ret = host_info(host_self(), HOST_BASIC_INFO,(host_info_t)&basic_info, &count);
if (ret != KERN_SUCCESS)
	{
    fprintf(stderr, "KernelInfo : Error calling host_info().\n");
	[maxCPU setStringValue:"Error"];
	[availableCPU setStringValue:"Error"];
	}
else
	{
	[maxCPU setIntValue:basic_info.max_cpus];
	[availableCPU setIntValue:basic_info.avail_cpus];
	}

ret = host_info(host_self(), HOST_SCHED_INFO,
								(host_info_t)&sched_info, &sched_count);
if (ret != KERN_SUCCESS)
	{
    fprintf(stderr, "KernelInfo : Error calling host_info(2).\n");
	[minTimeout setStringValue:"Error"];
	[minQuantum setStringValue:"Error"];
	}
else
	{
	[minTimeout setIntValue:sched_info.min_timeout];
	[minQuantum setIntValue:sched_info.min_quantum];
	}

return self;
}


@end
