// VMGraphs.m
//

#import "VMGraphs.h"

@implementation VMGraphs


- loadEverythingFrom:(char *)theDir
{
int		i;

[super loadEverythingFrom:theDir];

graph[0] = graph0;
graph[1] = graph1;
graph[2] = graph2;
graph[3] = graph3;

dataIndex[0] = 1;
dataIndex[1] = 2;
dataIndex[2] = 5;
dataIndex[3] = 6;

popupButton[0] = popupButton0;
popupButton[1] = popupButton1;
popupButton[2] = popupButton2;
popupButton[3] = popupButton3;

for (i = 0; i < 4; i++)
	[graph[i] initMin:0 max:0 title:[popupButton[i] title] numFormat:"%.0f"];

return MyView;
}

////////////////////////////////////////////////////////////////
//

- doUpdateForCell:theCell
{
kern_return_t			error;
long					theStats[sizeof(vm_statistics_data_t)/sizeof(long)];
int						i;

[theCell setUpdater:self];

error = vm_statistics(task_self(), theStats);
if (error != KERN_SUCCESS)
	[MyMaster addMessage:"VMGraphs : error calling vm_statistics().\n"];
else
	for (i = 0; i < 4; i++)
		if (dataIndex[i] < 5)
			[graph[i] addPoint:theStats[dataIndex[i]]];
		else
			[graph[i] addDeltaPoint:theStats[dataIndex[i]]];

return self;
}

////////////////////////////////////////////////////////////////
//

- dataPopup:sender
{
int		whichGraph;

whichGraph = [[sender selectedCell] tag] / 100;
if (whichGraph > 3 || whichGraph < 0)
	[MyMaster addMessage:"VMGraphs : unknown graph\n"];
dataIndex[whichGraph] = ([[sender selectedCell] tag] % 100) + 1;
if (dataIndex[whichGraph] > 12 || dataIndex[whichGraph] < 1)
	[MyMaster addMessage:"VMGraphs : impossible dataIndex\n"];
[graph[whichGraph] initMin:0 max:0 title:[[sender selectedCell] title] 
															numFormat:"%.0f"];
return self;
}

////////////////////////////////////////////////////////////////
//

- (int) updateInterval
{
return 3;
}

@end
