// VMInfo.m
//

#import "VMInfo.h"

@implementation VMInfo


////////////////////////////////////////////////////////////////
//

- doUpdateForCell:theCell
{
kern_return_t			error;
vm_statistics_data_t	theStats;

[theCell setUpdater:self];

error = vm_statistics(task_self(), &theStats);
if (error != KERN_SUCCESS)
	{
	fprintf(stderr, "VMInfo : Error calling vm_statistics().\n");
	[pageSize setStringValue:"Error"];
	[freePages setStringValue:"Error"];
	[activePages setStringValue:"Error"];
	[inactivePages setStringValue:"Error"];
	[wireddownPages setStringValue:"Error"];
	[zerofillPages setStringValue:"Error"];
	[reactivatedPages setStringValue:"Error"];
	[pageins setStringValue:"Error"];
	[pageouts setStringValue:"Error"];
	[faults setStringValue:"Error"];
	[COWs setStringValue:"Error"];
	[cacheLookups setStringValue:"Error"];
	[cacheHits setStringValue:"Error"];
	[hitRate setStringValue:"Error"];
	}
else
	{
	[pageSize setIntValue:theStats.pagesize];
	[freePages setIntValue:theStats.free_count];
	[activePages setIntValue:theStats.active_count];
	[inactivePages setIntValue:theStats.inactive_count];
	[wireddownPages setIntValue:theStats.wire_count];
	[zerofillPages setIntValue:theStats.zero_fill_count];
	[reactivatedPages setIntValue:theStats.reactivations];
	[pageins setIntValue:theStats.pageins];
	[pageouts setIntValue:theStats.pageouts];
	[faults setIntValue:theStats.faults];
	[COWs setIntValue:theStats.cow_faults];
	[cacheLookups setIntValue:theStats.lookups];
	[cacheHits setIntValue:theStats.hits];
	[hitRate setIntValue:(theStats.hits / (float)theStats.lookups) * 100.0];
	}

return self;
}

////////////////////////////////////////////////////////////////
//

- (int) updateInterval
{
return 5;
}

@end
