// UserStats.m
//
// History :
//		10.07.1992 : created by Max Tardiveau

#import "UserStats.h"

@implementation UserStats


////////////////////////////////////////////////////////////////
//

- init
{
[super init];

myFont = [Font newFont:"Ohlfs"  size:11.0];

return self;
}

////////////////////////////////////////////////////////////////
//

static void formatDuration(long seconds, char *buffer)
{
long		minutes = 0, hours = 0, days = 0;

if (seconds >= (60*60*24))
	{
	days = seconds / (60*60*24);
	seconds %= (60*60*24);
	}
if (seconds >= (60*60))
	{
	hours = seconds / (60*60);
	seconds %= (60*60);
	}
if (seconds >= 60)
	{
	minutes = seconds / 60;
	}

if (days)
	sprintf(buffer, "%3id %2ih %2im", days, hours, minutes);
else if (hours)
	sprintf(buffer, "     %2ih %2im", hours, minutes);
else if (minutes)
	sprintf(buffer, "         %2im", minutes);
else
	sprintf(buffer, "          0m");
}

////////////////////////////////////////////////////////////////
//

- AddLine:(long)LoginTime :(long)LogoutTime :(char *)ttyName :(char *)hostName
					:(int)logoutType
{
char		tmpChar[100];
char		loginChar[40], logoutChar[40];
char		timeOn[30];

strcpy(loginChar, ctime(&LoginTime));
loginChar[16] = ' ';
loginChar[17] = loginChar[22];
loginChar[18] = loginChar[23];
loginChar[19] = '\0';

if (LogoutTime)
	{
	strcpy(logoutChar, ctime(&LogoutTime));
	logoutChar[16] = ' ';
	logoutChar[17] = logoutChar[22];
	logoutChar[18] = logoutChar[23];
	logoutChar[19] = '\0';
	formatDuration(LogoutTime - LoginTime, timeOn);
	}
else
	{
	sprintf(logoutChar, "Still logged in    ");
	formatDuration(time(0) - LoginTime, timeOn);
	}

switch (logoutType)
	{
	case 0 :
		sprintf(tmpChar, "%s | %s | %s |%8s |%.9s\n", loginChar, timeOn, 
											logoutChar, ttyName, hostName);
		break;
	
	case 1 :
		sprintf(tmpChar, "%s | %s |*%s |%8s |%.9s\n", loginChar, timeOn, 
											logoutChar, ttyName, hostName);
		break;

	case 2 :
		sprintf(tmpChar, "%s | %s |?%s |%8s |%.9s\n", loginChar, timeOn, 
											logoutChar, ttyName, hostName);
		break;
	}
	
[[myScrollView docView] setSel:1000000 :1000000];
[[myScrollView docView] replaceSel:tmpChar];

return self;
}


////////////////////////////////////////////////////////////////
//

#define MAXTTYS 20

- doUpdateForCell:theCell
{
FILE		*wtmpFile;
struct utmp tmpEntry;
id			myText;
typedef struct ttyEnt
	{
	char 	name[10];
	long	loginTime;
	char	host[18];
	} TTYentry;
TTYentry	TTYarray[MAXTTYS];
struct passwd *thePassword;
int			i;
int			flag;

myText = [myScrollView docView];
[myText setText:""];

for (i = 0; i < MAXTTYS; i++)
	TTYarray[i].loginTime = 0;

thePassword = getpwuid((int)[theCell freePointer]);
if (thePassword == NULL)
	{
	fprintf(stderr, "UserStats : error in getpwuid().\n");
	return self;
	}

wtmpFile = fopen("/usr/adm/wtmp", "r");

while (fread(&tmpEntry, sizeof(struct utmp), 1, wtmpFile))
	{
	if (tmpEntry.ut_line[0] == '~')		// reboot : flush all slots
		{
		for (i = 0; i < MAXTTYS; i++)
			if (TTYarray[i].loginTime)
				{
				[self AddLine:TTYarray[i].loginTime :tmpEntry.ut_time 
								:TTYarray[i].name :TTYarray[i].host :1];
				TTYarray[i].loginTime = 0;		// free the slot
				}
	
		continue;
		}
	
	flag = 0;
	for (i = 0; i < MAXTTYS; i++)
		if (TTYarray[i].loginTime)
			if ( ! strncmp(TTYarray[i].name, tmpEntry.ut_line, 8))
				{
				if (strlen(tmpEntry.ut_name) > 0)	// not a simple logout
					[self AddLine:TTYarray[i].loginTime :tmpEntry.ut_time 
									:TTYarray[i].name :TTYarray[i].host :2];
				else
					[self AddLine:TTYarray[i].loginTime :tmpEntry.ut_time 
									:TTYarray[i].name :TTYarray[i].host :0];

				TTYarray[i].loginTime = 0;		// free the slot
				
				if ( strncmp(thePassword->pw_name, tmpEntry.ut_name, 8))
					flag = 1;
				break;
				}
	
	if (flag)			// It was a logout
		continue;
	
	if ( strncmp(thePassword->pw_name, tmpEntry.ut_name, 8))
		continue;
	
	for (i = 0; i < MAXTTYS; i++)
		if (TTYarray[i].loginTime == 0)
			{
			TTYarray[i].loginTime = tmpEntry.ut_time;
			strncpy(TTYarray[i].name, tmpEntry.ut_line, 8);
			strncpy(TTYarray[i].host, tmpEntry.ut_host, 16);
			break;
			}
	
	}

for (i = 0; i < MAXTTYS; i++)
	if (TTYarray[i].loginTime)
		[self AddLine:TTYarray[i].loginTime :0
								:TTYarray[i].name :TTYarray[i].host :0];

[myText setFont:myFont];

fclose(wtmpFile);

return self;
}

@end
