// Users.m
//
// History :
//		10.06.1992 : created by Max Tardiveau

#import "Users.h"

@implementation Users


////////////////////////////////////////////////////////////////
// 

- init
{
[super init];

BoldFont = [Font newFont:"Helvetica-Bold"  size:12.0];

return self;
}

////////////////////////////////////////////////////////////////
// 

- fillList:theMatrix fromCell:theCell
{
id					newCell;
struct passwd		*thePassword;

if ([theCell updater])		// It's a user
	{
	[self fillSubList:theMatrix ofCell:theCell pointer:[theCell freePointer]];
	return self;
	}

// It's the .list item
setpwent();
while (thePassword = getpwent())
	{
	[theMatrix addRow];
	newCell = [theMatrix cellAt:([theMatrix cellCount] - 1) :0];
	[newCell setStringValue:thePassword->pw_name];
	[newCell setFreePointer:(void *)thePassword->pw_uid];
	[newCell setUpdater:self];
	[newCell setDir:[theCell getDir]];
	}

[theCell setMasterInstance:self];

return self;
}

////////////////////////////////////////////////////////////////
//

- doUpdateForCell:theCell
{
struct passwd		*thePassword;

thePassword = getpwuid((int)[theCell freePointer]);
if (thePassword)
	{
	[userName setStringValue:thePassword->pw_name];
	[userID setIntValue:thePassword->pw_uid];
	[password setStringValue:thePassword->pw_passwd];
	[userGecos setStringValue:thePassword->pw_gecos];
	[homeDir setStringValue:thePassword->pw_dir];
	[shell setStringValue:thePassword->pw_shell];
	}
else
	{
	[userName setStringValue:"Error"];
	[userID setStringValue:"Error"];
	[password setStringValue:"Error"];
	[userGecos setStringValue:"Error"];
	[homeDir setStringValue:"Error"];
	[shell setStringValue:"Error"];
	}

[groupList loadColumnZero];

return self;
}

////////////////////////////////////////////////////////////////
//

- (int)browser:sender fillMatrix:theMatrix inColumn:(int)column
{
id					newCell;
struct group		*theGroup;
struct passwd		*thePassword;
int					i;

thePassword = getpwuid((int)[userID intValue]);
if ( thePassword == NULL)
	{
	fprintf(stderr, "Users : error in getpwuid(1).\n");
	return 0;
	}

setgrent();
while (theGroup = getgrent())
	{
	if (theGroup->gr_gid == thePassword->pw_gid)
		{
		[theMatrix addRow];
		newCell = [theMatrix cellAt:([theMatrix cellCount] - 1) :0];
		[newCell setStringValue:theGroup->gr_name];
		[newCell setLeaf:YES];
		[newCell setFont:BoldFont];
		}
	else for (i = 0; theGroup->gr_mem[i]; i++)
		if ( ! strncmp(thePassword->pw_name, theGroup->gr_mem[i], 8))
			{
			[theMatrix addRow];
			newCell = [theMatrix cellAt:([theMatrix cellCount] - 1) :0];
			[newCell setStringValue:theGroup->gr_name];
			[newCell setLeaf:YES];
			}
	}

return [theMatrix cellCount];
}

@end
