// WScontexts.m
//
// History :
//		10.17.1992 : created by Max Tardiveau

#import "WScontexts.h"

@implementation WScontexts


////////////////////////////////////////////////////////////////
// Function used to get results from WS. This is lifted straight
// from the NeXT on-line doc.

static char *responseBuffer;    // Pointer to character buffer
static int   responseBufCount;  // Number of bytes in buffer currently
static int   responseBufSize;   // Total size of buffer
#define MINRESPBUFSIZE 500

static void myTextProc(DPSContext context, char *buf, long unsigned int count)
{
while((count + responseBufCount + 1) > responseBufSize)
	{    // Must expand buffer
	if (responseBuffer == NULL)
		{
		responseBuffer = malloc(MINRESPBUFSIZE);
		responseBufSize = MINRESPBUFSIZE;
		}
	else
		{
		responseBuffer = realloc(responseBuffer,responseBufSize*2);
		responseBufSize *= 2;
		}
	}

// Put the new data in the buffer and update the count

bcopy(buf,responseBuffer+responseBufCount,count);
responseBufCount += count;

// And null-terminate the buffer (this is used by the main procedure)

*(responseBuffer+responseBufCount) = 0;
}

////////////////////////////////////////////////////////////////
// 

- fillList:theMatrix fromCell:theCell
{
int			cellCount;
id			newCell;
DPSTextProc	oldTextProc;
DPSContext	context;
char		*buf,*bufEnd,*newBuf;
int			tmpContext;
char		tmpChar[32];

if ([theCell updater])		// It's a processor set
	{
	[self fillSubList:theMatrix ofCell:theCell pointer:[theCell freePointer]];
	return self;
	}

responseBuffer = NULL;
responseBufSize = responseBufCount = 0;

context = DPSGetCurrentContext();
oldTextProc = context->textProc;
DPSSetTextProc(context,myTextProc);

DPSPrintf(context,
	"nextdict /windowPackage get /_contextData get {pop ==} forall flush\n");

DPSWaitContext(context);
DPSSetTextProc(context,oldTextProc);

if (responseBuffer)
	{
	buf = responseBuffer;
	bufEnd = buf + responseBufCount + 1;

	while(buf < bufEnd)
		{
		newBuf = index(buf,'\n');
		if (!newBuf)
			break; // Every line we want has a newline.

		*newBuf = 0;
		
		[theMatrix addRow];
		cellCount = [theMatrix cellCount];
		newCell = [theMatrix cellAt:(cellCount - 1) :0];
		tmpContext = atoi(buf);
		sprintf(tmpChar, "Context %p", (void *)tmpContext);
		[newCell setStringValue:tmpChar];
		[newCell setFreePointer:(void *)tmpContext];
		[newCell setUpdater:self];
		[newCell setDir:[theCell getDir]];
		buf = newBuf + 1;
		}
	free(responseBuffer);
	}

[theCell setMasterInstance:self];

return self;
}

////////////////////////////////////////////////////////////////
//

static int theContext;

static int *getWindowCount()	// This one returns a signed value on 8 bit !!!
{
static int		tmpInt;

PScountwindowlist(theContext, &tmpInt);
return &tmpInt;
}

//////////////////

static int *getScreenListCount()
{
static int		tmpInt;

PScountscreenlist(theContext, &tmpInt);
return &tmpInt;
}

/////////////////

#define MAXWINS 256

static int *getWindowList()
{
static int		Wins[MAXWINS];
int				count;

PScountwindowlist(theContext, &count);
PSwindowlist(theContext, count, Wins);
Wins[count] = -1;				// terminate the list

return Wins;
}

///////////////////////////////////////////////////////////////

- doUpdateForCell:theCell
{
char		tmpChar[32];
int			screenList, total;
DPSTextProc	oldTextProc;
DPSContext	context;
int			*WinList;
int			tmpInt, tmpInt2;
int			backingStore, backingTotal;
int			i;

sprintf(tmpChar, "%p", [theCell freePointer]);
[contextNumber setStringValue:tmpChar];

theContext = (int)[theCell freePointer];
screenList = *[MyMaster runFunction:getScreenListCount];
total = *[MyMaster runFunction:getWindowCount];
[windowsOnScreen setIntValue:screenList];
[windowsTotal setIntValue:total];

backingStore = backingTotal = 0;

WinList = (int *)[MyMaster runFunction:getWindowList];
for (i = 0; WinList[i] != -1; i++)
	{
	responseBuffer = NULL;
	responseBufSize = responseBufCount = 0;
	
	context = DPSGetCurrentContext();
	oldTextProc = context->textProc;
	DPSSetTextProc(context,myTextProc);
	
	DPSPrintf(context,"0 %i dumpwindow\n", WinList[i]);
	
	DPSWaitContext(context);
	DPSSetTextProc(context,oldTextProc);
	
	if (responseBuffer)
		{
		if (sscanf(responseBuffer, "%*s (%*d,%*d),(%*d,%*d) %d%*c %*s (%d)",
								&tmpInt, &tmpInt2) == 2)
			{
			backingStore += tmpInt;
			backingTotal += tmpInt2;
			}
		else
			(*oldTextProc)(context, responseBuffer,strlen(responseBuffer));

		free(responseBuffer);
		}
	}

[backStore setIntValue:backingStore];
[backStoreTotal setIntValue:backingTotal];

return self;
}

@end
