// WSdicts.m
//
// History :
//		10.16.1992 : created by Max Tardiveau

#import "WSdicts.h"

@implementation WSdicts


////////////////////////////////////////////////////////////////
// 

- init
{
[super init];
currentDict[0] = '\0';

return self;
}

////////////////////////////////////////////////////////////////
// Override this one to make InformerCell the class of the
// browser cells. Can't be done in init, since at that time
// the .nib file hasn't been loaded yet.

- loadEverythingFrom:(char *)theDir
{
[super loadEverythingFrom:theDir];
[myBrowser setCellClass:[InformerCell class]];
[myBrowser useScrollButtons:YES];

return self;
}

////////////////////////////////////////////////////////////////
// Function used to get results from WS. This is lifted straight
// from the NeXT on-line doc.

static char *responseBuffer;    // Pointer to character buffer
static int   responseBufCount;  // Number of bytes in buffer currently
static int   responseBufSize;   // Total size of buffer
#define MINRESPBUFSIZE 500

static void myTextProc(DPSContext context, char *buf, long unsigned int count)
{
while((count + responseBufCount + 1) > responseBufSize)
	{    // Must expand buffer
	if (responseBuffer == NULL)
		{
		responseBuffer = malloc(MINRESPBUFSIZE);
		responseBufSize = MINRESPBUFSIZE;
		}
	else
		{
		responseBuffer = realloc(responseBuffer,responseBufSize*2);
		responseBufSize *= 2;
		}
	}

// Put the new data in the buffer and update the count

bcopy(buf,responseBuffer+responseBufCount,count);
responseBufCount += count;

// And null-terminate the buffer (this is used by the main procedure)

*(responseBuffer+responseBufCount) = 0;
}

////////////////////////////////////////////////////////////////
// 

- fillList:theMatrix fromCell:theCell
{
char	*dictNames[] = {
				"internaldict",
				"systemdict",
				"userdict",
				"nextdict",
				"statusdict",
				"SharedFontDirectory"};
char	*dictAccess[] = {
				"1183615869 internaldict",
				"systemdict",
				"userdict",
				"nextdict",
				"statusdict",
				"SharedFontDirectory"};
int		i;
int		cellCount;
id		newCell;
				
if ([theCell updater])		// It's a processor set
	{
	[self fillSubList:theMatrix ofCell:theCell pointer:[theCell freePointer]];
	return self;
	}

for (i = 0; i < 6; i++)
	{
	[theMatrix addRow];
	cellCount = [theMatrix cellCount];
	newCell = [theMatrix cellAt:(cellCount - 1) :0];
	[newCell setStringValue:dictNames[i]];
	[newCell setFreeString:dictAccess[i]];
	[newCell setUpdater:self];
	[newCell setDir:[theCell getDir]];
	[newCell setLeaf:YES];
	}

[theCell setMasterInstance:self];

return self;
}

////////////////////////////////////////////////////////////////
//

- doUpdateForCell:theCell
{
[[myScrollView docView] setText:""];
strncpy(currentDict, [theCell freeString], FREESTRINGLEN - 1);
[myBrowser setTitle:[theCell stringValue] ofColumn:0];
[myBrowser loadColumnZero]; // REMOVE THIS

return self;
}

////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
// Browser methods

- cellClicked:sender
{
DPSTextProc	oldTextProc;
DPSContext	context;
id			CurrentCell;

responseBuffer = NULL;
responseBufSize = responseBufCount = 0;
[[myScrollView docView] setText:""];

context = DPSGetCurrentContext();
oldTextProc = context->textProc;
DPSSetTextProc(context,myTextProc);

CurrentCell = [[myBrowser matrixInColumn:
									[myBrowser selectedColumn]] selectedCell];

DPSPrintf(context,"%s == flush\n", [CurrentCell freeString]);

DPSWaitContext(context);
DPSSetTextProc(context,oldTextProc);

if (responseBuffer)
	{
	[[myScrollView docView] setText:responseBuffer];
	free(responseBuffer);
	}

return self;
}

////////////////////////////////////////////////////////////////
//

- (int)browser:sender fillMatrix:matrix inColumn:(int)column
{
id			newCell, CurrentCell;
int			cellCount;
DPSTextProc	oldTextProc;
DPSContext	context;
char		*buf,*bufEnd,*newBuf;
char		tmpChar[256];
char		*theDict;

if (column == 0)
	{
	theDict = currentDict;
	}
else
	{
	CurrentCell = [[myBrowser matrixInColumn:
									[myBrowser selectedColumn]] selectedCell];
	theDict = [CurrentCell freeString];
	}

responseBuffer = NULL;
responseBufSize = responseBufCount = 0;

context = DPSGetCurrentContext();
oldTextProc = context->textProc;
DPSSetTextProc(context,myTextProc);

DPSPrintf(context,
		"%s {type /dicttype eq {(%%%%DICT%%%%) print} if == } forall flush\n", 
		theDict);

DPSWaitContext(context);
DPSSetTextProc(context,oldTextProc);

if (responseBuffer)
	{
	buf = responseBuffer;
	bufEnd = buf + responseBufCount + 1;

	while(buf < bufEnd)
		{
		newBuf = index(buf,'\n');
		if (!newBuf)
			break; // Every line we want has a newline.

		*newBuf = 0;
		
		[matrix addRow];
		cellCount = [matrix cellCount];
		newCell = [matrix cellAt:([matrix cellCount] -1) :0];
		[newCell setFreePointer:(void *)0];
		[newCell setUpdater:self];
		if ( ! strncmp(buf, "%%DICT%%", 8))
			{
			buf += 8;
			[newCell setLeaf:NO];
			}
		else
			[newCell setLeaf:YES];
		[newCell setStringValue:buf];
		if ((buf[0] == '/') || ((buf[0] >= '0') && (buf[0] <= '9')))
			sprintf(tmpChar, "%s %s get", theDict, buf);
		else
			sprintf(tmpChar, "%s /%s get", theDict, buf);

		[newCell setFreeString:tmpChar];

		buf = newBuf + 1;
		}
	
	free(responseBuffer);
	}

return [matrix cellCount];
}

@end
