// WSgraphs.m
//

#import "WSgraphs.h"

@implementation WSgraphs


/////////////////////////////////////////////////////////////////
// This is very strange. The functions PScountscreenlist(),
// PScountwindowlist() and PSostype(), when called from a
// dynamically loaded module, return 0. So we have to have these
// functions run by our InformerWindow in order to get the
// result. Beats me.

static int *getWindowCount()	// This one returns a signed value on 8 bit !!!
{
static int		tmpInt;

PScountwindowlist(0, &tmpInt);
return &tmpInt;
}

static int *getScreenListCount()
{
static int		tmpInt;

PScountscreenlist(0, &tmpInt);
return &tmpInt;
}

//////////////////////////////////////////////////////////////////
//

- loadEverythingFrom:(char *)theDir
{
int		i;

[super loadEverythingFrom:theDir];

graph[0] = graph0;
graph[1] = graph1;
graph[2] = graph2;
graph[3] = graph3;

dataIndex[0] = 0;
dataIndex[1] = 1;
dataIndex[2] = 2;
dataIndex[3] = 3;

popupButton[0] = popupButton0;
popupButton[1] = popupButton1;
popupButton[2] = popupButton2;
popupButton[3] = popupButton3;

for (i = 0; i < 4; i++)
	if (i == 2 || i == 3)
		[graph[i] initMin:0 max:0.05 title:[popupButton[i] title] 
															numFormat:"%.3f"];
	else
		[graph[i] initMin:0 max:0 title:[popupButton[i] title] 
															numFormat:"%.0f"];

return MyView;
}

////////////////////////////////////////////////////////////////
//

- doUpdateForCell:theCell
{
char		tmpInt;
float		values[9];
float		pnow, puTime, psTime;
int			pmsgSend, pmsgRcv, pnSignals, pnVCSw, pnIvCSw;
int			i;

[theCell setUpdater:self];

tmpInt = *[MyMaster runFunction:getWindowCount];
values[0] = tmpInt <= 0 ? tmpInt + 256 : tmpInt;
tmpInt = *[MyMaster runFunction:getScreenListCount];
values[1] = tmpInt <= 0 ? tmpInt + 256 : tmpInt;
PScurrentrusage(&pnow, &puTime, &psTime, &pmsgSend, &pmsgRcv, &pnSignals, 
															&pnVCSw, &pnIvCSw);
values[2] = puTime;
values[3] = psTime;
values[4] = pnSignals;
values[5] = pmsgSend;
values[6] = pmsgRcv;
values[7] = pnVCSw;
values[8] = pnIvCSw;

for (i = 0; i < 4; i++)
	if (dataIndex[i] < 2)
		[graph[i] addPoint:values[dataIndex[i]]];
	else
		[graph[i] addDeltaPoint:values[dataIndex[i]]];

return self;
}

////////////////////////////////////////////////////////////////
//

- dataPopup:sender
{
int		whichGraph;

whichGraph = [[sender selectedCell] tag] / 100;
if (whichGraph > 3 || whichGraph < 0)
	[MyMaster addMessage:"WSgraphs : unknown graph\n"];
dataIndex[whichGraph] = [[sender selectedCell] tag] % 100;
if (dataIndex[whichGraph] > 8 || dataIndex[whichGraph] < 0)
	[MyMaster addMessage:"WSgraphs : impossible dataIndex\n"];
if (dataIndex[whichGraph] == 2 || dataIndex[whichGraph] == 3)
	[graph[whichGraph] initMin:0 max:0.05 title:[[sender selectedCell] title] 
															numFormat:"%.3f"];
else
	[graph[whichGraph] initMin:0 max:0 title:[[sender selectedCell] title] 
															numFormat:"%.0f"];
return self;
}

////////////////////////////////////////////////////////////////
//

- (int) updateInterval
{
return 3;
}

@end
