// InformerWindow.h
//
// History :
//		9.20.1992 : created by Max Tardiveau


#import <sys/types.h>
#import <sys/dir.h>
#import <sys/stat.h>

#import <objc/Object.h>
#import <appkit/Application.h>
#import <appkit/Window.h>
#import <appkit/NXBrowser.h>
#import <appkit/NXBrowserCell.h>
#import <appkit/Matrix.h>
#import <appkit/ScrollView.h>
#import <appkit/Text.h>
#import <appkit/Button.h>
#import <appkit/NXCursor.h>
#import <dpsclient/dpsclient.h>
#import <sound/sound.h>

#import "InformerDispatcher.h"
#import "InformerCell.h"
#import "EmptyView.h"
#import "InformerInspector.h"

@interface InformerWindow:Object
{
id				myWindow;			// my window
id				myHelpPanel;		// the Help panel
id				myHelpText;			// the Help ScrollView
id				myBrowser;			// the Browser in the window
id				myInspectorView;	// the InspectorView in the window
id				myEmptyView;		// to fill the space
id				myDispatcher;	// the InformerDispatcher responsible for me
id				updateScroller;
id				updateText;
id				updateTextSeconds;
id				helpButton;
id				messageScrollView;
DPSTimedEntry 	myTimedEntry;
long			updatePeriod;

}


- init;

- cellClicked:sender;

- setDispatcher:sender;

- setUpdate:sender;

- helpClicked:sender;

- addMessage:(char *)theMessage;

- clearMessages:sender;

- (int *) runFunction:(int * (*)())theFunction;

- window;

///////////////////////////////////////////////////////
// Delegate methods

- (int)browser:sender fillMatrix:matrix inColumn:(int)column;

- windowDidBecomeMain:sender;

- windowDidBecomeKey:sender;

- windowDidResignKey:sender;

- windowWillClose:sender;



@end
