// Inquirer.h
// SCSI Bus Inquirer  - NeXTStep 
//
// Copyright (C) 1990 by Jiro Nakamura and Canon Inc.
// Copyright (C) 1991 by Jiro Nakamura.
// Copyright (C) 1992 by Jiro Nakamura
// All Rights Reserved.
//
// Original Author:	Jiro Nakamura (jiro@shaman.com)
// Created:		June 11, 1990
//
// RCS Information
// Revision Number->	$Revision: 2.0 $
// Last Revised->	$Date: 92/11/14 01:37:26 $
// ------------------
//
// HISTORY
// 	May-17-92	Jiro
//		Cleaned up and added tape drive support
//	Dec- 7-91	Jiro
//		Googles of revisions. Version 2.0.
//		Commercial release.
//	Aug- 8-90	Jiro
//		Revised to read disk capacity and released source.
//	Jul-13-90	Jiro
//		Revised to handle new versions of SCSI. Improved and cleaned up.
//	Jun-11-90	Jiro Nakamura at Canon   (ac6y@vax5.cit.cornell.edu)
//		Created.
//
// There are not many comments because I was not in a commenting mood.
//

#import "SCSIControlWindow.h"

@interface Inquirer: SCSIControlWindow
{
	id scsi2TextScroll;
	id scsi2Text;
	
	id diagnosticsPanel;
	id diagnosticsTextScroll;
	id diagnosticsText;
	
}

- (int) setTarget: (int) target lun: (int) lun;
- scsi2DADFeatures: (NXStream *) output;
- scsi2SADFeatures: (NXStream *) output;
- (const char *) mediumTypeDescription: (int) mt;

- performDiagnostics: sender;
- scsi2GenericDiagnostics: (NXStream *)output;
- scsi2DADDiagnostics: (NXStream *)output;

- windowWillResize: (id) sender toSize: (NXSize *) size;	// Window
				// is resizing, check constraints

- (const char *) appName;

@end
