// SCSISelectorPanel.h
// SCSI Bus Inquirer  - NeXTStep 
//
// Copyright (C) 1990 by Jiro Nakamura and Canon Inc.
// Copyright (C) 1991,1992 by Jiro Nakamura.
// All Rights Reserved.
//
// Original Author:	Jiro Nakamura (jiro@shaman.com)
// Created:		June 11, 1990
//
// RCS Information
// Revision Number->	$Revision: 1.7 $
// Last Revised->	$Date: 92/11/13 23:32:08 $
// ------------------
//
// There are not many comments because I was not in a commenting mood.
//

#import <appkit/Panel.h>
#import <sys/types.h>
#import <bsd/dev/scsireg.h>
#import <mntent.h>
#define VERSION		"Release 0.9.1 (v2) beta"

struct	mountentry{
	char	mnt_fsname[MNTMAXSTR];	
	char	mnt_dir[1024];	
	char	mnt_type[MNTMAXSTR];		
	char	mnt_opts[MNTMAXSTR];		
	int	mnt_freq;		/* dump frequency, in days */
	int	mnt_passno;		/* pass number on parallel fsck */
};

@interface SCSISelectorPanel:Panel
{

	id	infoPanel;
	id	legalPanel;
	id	helpPanel;
	id	calculatorPanel;

	id deviceButtonMatrix;
    	id Title0;
	id Title1;
	id Title2;
	id Title3;
	id Title4;
	id Title5;
	id Title6;
	id Title7;
	
	id controlWindow;
	
	id passwordPanel;
	id passwordText;
	id	installSelfMenuItem;		
	
	struct DeviceInfo
		{
		BOOL deviceValid;
		struct inquiry_reply ir;
		char vendorID[8];
		char productID[20];
		char rawDevice[15];
		char blockDevice[15];
		BOOL mounted;
		BOOL removable;
		} devInfo[7];
	
	
}

- info:	sender;			// Main menu->Info Bring up info panel
- help:	sender;			// Main menu->help Bring up help panel
- legal: sender;		// Main menu->legal Bring up legal panel
- calculator: sender;

- inquireAll:sender;
- inquireTarget: (int) target;
- inquireSelected: sender;

- installSelf: sender;

- appDidInit: sender;

- (BOOL) targetIsMounted: (int) targ;
- (BOOL) targetRemovable: (int) targ;
- (int) targetDeviceType: (int) targ;
- (char *) targetRawDevice: (int) targ;
- (char *) targetVendorID: (int) targ;
- (char *) targetProductID: (int) targ;

@end
