
//======================================================================
//
//	Portions written by FreemanSoft Inc.
//
//	FreemanSoft disclaims any warranty of any kind, expressed or implied,
//	as to this source code's fitness for any particular use.
//
//	For more information, use the following electronic mail addresses:
//	 
//		info@FreemanSoft.com	general questions
//		support@FreemanSoft.com	technical questions
//
//======================================================================


/* 
 * JumpBackControl
 *	Written by
 *	Joe Freeman	jfreeman@next.com	
 *
 *	This code has no warranty.  
 *	It is provided so that the consumer may maintain and modify it
 *	at their own risk.  Use this code at your own risk.
 */


#import <appkit/appkit.h>
#define JBC_MAX_PAIR	256

@interface JumpBackControl:Object
{
    List *	dragBackList;
    List *	scriptBackList;

    id  infoPanel;	
    id	versionField;		/* so we can put the version number up */	
    id	prefPanel;
    id	pairingsMenu;		/* menu cell */
    
    char *	pairMenu[JBC_MAX_PAIR];
    char *	pairSrc[JBC_MAX_PAIR];
    char *	pairDest[JBC_MAX_PAIR];
    int 	pairNum;	/* number of menu cells added via predefined */
}


- appDidInit:sender;
- appWillTerminate:sender;

/*================================================================
 * predefined src/dest pair support
 *================================================================*/

- loadPredefined:sender;
- selectPredefined:sender;

/*================================================================
 *
 *================================================================*/

- newDragController:sender;
- newUnrelatedTool:sender;

/*================================================================
 *
 *================================================================*/

				/* 
				 * this class goes and notifies all
				 * open sessions
				 */
- preferencesChanged:sender;		

				/* 
				 * aController is going away, so it
				 * notifies this object
				 */
- dropDragJumpBackController:aController;

				/*
				 * caller closes stream when done 
				 * first try ~/Library/JumpBack 
				 * then get it out of app wrapper 
				 * wrapper version ends in .template
				 */
- (NXStream *)mapResource:(const char *)resourceName;

/*================================================================
 *
 *================================================================*/
- showInfoPanel:sender;
- showPrefPanel:sender;

@end
