
/* Generated by Interface Builder */

#import <appkit/appkit.h>
#import "table_compat.h"	/* header file with some key definitions
				 * in it.  This is part of sys/table.h as
				 * was in NS-2.1, but that include file
				 * was removed in NS-3.0 */

struct perfData
{
    unsigned char 	system;
    unsigned char 	user;
    unsigned char 	nice;
    unsigned int	free;
    unsigned int	active;
    unsigned int	inactive;
    unsigned int	wired;
    unsigned int	netin;
    unsigned int	netout;
    unsigned int	netcollision;
    unsigned int	disk;
    unsigned int	pagein;
    unsigned int	pageout;
};
#define PERFDATA_DESC "{ccciiiiiiiiii}"

/*  Note that the following values have to match the tags
 *  in the list of menu items (in the KPerfMon.nib file).
 */
#define CPU_tag     0
#define DISK_tag    1
#define MEMORY_tag  2
#define NETWORK_tag 3
#define VM_tag      4			/* **  not implemented (yet?)  ** */
#define DISPTAG_MAX 3			/* (until VM is implemented...) */

@interface Monitor:View
{
    long oldTimes[CPUSTATES];
    long oldTotal;
    struct perfData current;	// The current statistics.
    int infoType;
    int oldin;
    int oldout;
    int oldpagein;
    int oldpageout;
    int olddisk;
    int oldcollision;
    Storage *stats;
    NXImage *cpuTiff;
    NXImage *vmTiff;
    NXImage *memTiff;
    NXImage *diskTiff;
    NXImage *networkTiff;
    NXImage *net_en0Tiff;
    NXImage *net_pniTiff;
    NXImage *net_pppTiff;
    
    int  netInterface_Index, disk_Index;

    struct tbl_cpuinfo tc;
    struct tbl_netinfo netstat;
    struct tbl_diskinfo diskstat;
    struct tbl_ioinfo iostat;
}

/*****************************************************************************
 *    Override methods                                                       *
 *****************************************************************************/
- initFrame:(NXRect *)frameRect;
- drawSelf:(NXRect *)rects :(int)rectCount;

/*****************************************************************************
 *    New methods                                                            *
 *****************************************************************************/
- flip:sender;
- step;
- (BOOL)diskstatAvailable;
- (BOOL)netstatAvailable;

@end
