/************************* Layer III MPEG Audio Encoder  ***************************
*                                                                                  *
*                     (c) copyright Fraunhofer-IIS (1995-03-31)                    *
*                               All Rights Reserved                                *
*                                                                                  *
***********************************************************************************/

/* $Date:$ */
/* $Header:$ */
/* $Log:$
 *
 */


/*********************************************************************
 *                                                                   *
 *  filename    : FhGRegister.h                                      *
 *  project     :                                                    *
 *  author      : J&uml;rgen Zeller                                  *
 *  date        : 03.07.95                                           *
 *  last change :                                                    *
 *  contents/description:                                            *
 *            Class declaration for the shareware                    *
 *            registration functions                                 *
 *                                                                   *
 *********************************************************************/


/*
 * --- DATA DEFINITIONS --- 
 */

typedef struct _reginfo {
    char    comptype[3]; /* "PC" for DOS / "SU" for SUN / each 0-terminated */
    int     version;     /* 99 for 0.99 / 123 for 1.23 / up to 999 for 9.99 */
    char    subversion;  /* A-Z (always uppercase) or "-" for no subversion */
    int     serialno;    /* serial number for each user, ranging 0001..9999 */
} reginfo;


/*
 * --- CLASS DEFINITIONS --- 
 */

@interface FhGRegister:Object
{
    reginfo    theRegInfo;
    char       theKey[15];
    BOOL       keySet;
}


/*
 * setRegistrationKey returns:
 *       0 = ok, registration is valid
 *    -100 = string shorter/longer than 14 characters
 *    -101 = crc in string not readable
 *    -102 = crc wrong
 *    -103 = registration invalid
 */
- (int) setRegistrationKey: (const char *) aKey;


/*
 * registrationKey returns a pointer to the key or NULL if
 * no was set.
 */
- (const char*) registrationKey;


/*
 * isRegistrated returns TRUE if the set key is valid.
 */
- (BOOL) isRegistrated;


/*
 * computerType returns a pointer to the computer type of the key
 * or NULL if no valid registration key was set.
 */
- (const char*) computerType;


/*
 * version returns the version of the key of the key or 0 if no
 * valid registration key was set.
 */
- (int) version;


/*
 * subversion returns the subversion of the key or 0 if no
 * valid registration key was set.
 */
- (int) subversion;


/*
 * serialNumber returns the serial number of the key or 0 if no
 * valid registration key was set.
 */
- (int) serialNumber;


@end

