/* --------------------------------------------------------------------------

Class:			MHAppManager
Version:		0.1
File:			MHAppManager.h				 

Written by:		Thomas Engel
Created:		17.05.1995	(Copyleft)
Last modified:	17.05.1995


Note:	For a detailed description please read the class documentation.

 ------------------------------------------------------------------------- */


#import <appkit/appkit.h>

@interface MHAppManager:Object
{
	id	info;
	id	preferences;
	
	id	sharedDocConverter;
}

// Some methods need to get the app started..

- appWillInit:sender;
- appDidInit:sender;
- (int)app:sender openFile:(const char *)path type:(const char *)type;
- (BOOL)appAcceptsAnotherFile:sender;
- appDidBecomeActive:sender;
- appWillTerminate:sender;

- (int)openFile:(const char *)path;
- (BOOL)_alreadyLoaded:(char *)aFile;

// Here we do the handling of our Panels & Tools

- showInfo:sender;
- showPreferences:sender;
- preferences;

// Here we have the methods the control our document. They work via the
// first responder chain.

- open:sender;

@end

/*
 * History: 13.01.95 Bla.
 *
 *
 * Hints: This Object could be defined as a subclass of a general docManager
 *		 like the one provided by the NeXT-miniexamples...Maybe later or never
 *
 *
 * Bugs: No bugs and birds seen....
 */