/* File: Magnify.h - Application class for 'Magnify'
 *
 * By: Christopher Lane <lane@camis.stanford.edu>
 * Symbolic Systems Resources Group
 * Knowledge Systems Laboratory
 * Stanford University
 *
 * PostScript optimizations by: Scott Byer <byer@adobe.com>
 *
 * Date:  13 May 1994
 *
 * Copyright: 1990, 1991, 1992  & 1994 by The Leland Stanford Junior University.
 * This program may be distributed without restriction for non-commercial use.
 */
 
#import <appkit/Application.h>

@interface Magnify : Application
{ 
	id version;
	id defaults;
	id magnifyView;
	id magnifyWindow;
	id gridField;
	id gridSlider;
	id gridButton;
	id scaleField;
	id scaleSlider;
	id updateField;
	id updateSlider;
	id updateButton;
	id cursorButton;
	id defaultField;
	id defaultButton;
	id defaultPopUpList;
	id saveButton;
	id removeButton;
	id crossCursor;
}

+ new;

- appDidInit:sender;
- appWillTerminate:sender;
- appDidHide:sender;
- appDidUnhide:sender;

- adjust:sender;

- changeScale:sender;
- setScale:(float) scale;

- changeGrid:sender;
- setGridSize:(float) size andEnable:(BOOL) flag;

- changeUpdate:sender;
- setUpdateRate:(double) update andEnable:(BOOL) flag;

- toggleFrozen:sender;
- toggleCursor:sender;

- magnifyView;

- loadDefaultSets;
- saveDefaultSetList;
- selectDefaultSet:sender;
- selectDefaultSetNamed:(const char *) name;
- saveDefaultSet:sender;
- saveDefaultSetNamed:(const char *) name;
- removeDefaultSet:sender;
- removeDefaultSetNamed:(const char *) name;
- setDefaultPopUpList:object;

- setVersion:anObject;
- (int) msgVersion:(const char **) aString ok:(int *) flag;

@end
