/*+++*
 *  title:	MailboxInspector.h
 *  abstract:	interface definitions for WM MailboxInspector 
 *  author:	T.R.Hageman, The Netherlands
 *  created:	May 1996
 *  modified:	(see RCS Log at end)
 *  copyleft:
 *
 *		Copyright (C) 1996  Tom R. Hageman.
 *
 *	This is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License as published by
 *	the Free Software Foundation; either version 2 of the License, or
 *	(at your option) any later version.
 *
 *	This software is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this software; see the file COPYING.  If not, write to
 *	the Free Software Foundation, 59 Temple Place - Suite 330,
 *	Boston, MA 02111-1307, USA.
 *
 *  description:
 *
 *  RCS MailboxInspector.h,v 1.2 1996/06/27 20:04:40 tom Exp
 *
 *---*/

#import <appkit/appkit.h>
#import <apps/Workspace.h>

#include <sys/stat.h>

#define FILE_TOC	"table_of_contents"
#define FILE_INDEX	"content.store"

enum { STAT_TOC, STAT_INDEX, NUMSTATS };

#define FILESTOSTAT	FILE_TOC, FILE_INDEX

// Tag values for matrix fields.
enum { TAG_TOTAL, TAG_DELETED, TAG_READ, TAG_FLAGGED, TAG_UNREAD, TAG_NEW,
       NUMTAGS };


@interface MailboxInspector : WMInspector
{
	// Outlets
    id	indexTagButton;
    id	indexSizeField;
    id	messageCountMatrix;
    id	messageSizeMatrix;
    id	attachmentCountMatrix;
    id	attachmentSizeMatrix;
    id	newMailIconButton;
    id	newMailTextField;

    id	inspectorVersionField;
    id	infoPanel;
    id	infoVersionField;

	// other variables.
	NXBundle *bundle;		// class bundle.
	NXBundle *mailbox;		// mailbox bundle.
	struct stat stats[NUMSTATS];	// for lazy inspection.
}

- showInfo:sender;

-open:sender;

// The workhorses
-(BOOL)shouldLoad;
-load;

// Support methods
-(const char *)getPath:(char *)path forFile:(const char *)type;
-(const char *)formatSize:(unsigned long)size inBuf:(char *)buf;

@end // MailboxInspector

//======================================================================
// MailboxInspector.h,v
// Revision 1.2  1996/06/27 20:04:40  tom
// (indexSizeField): new outlet.
//
// Revision 1.1  1996/06/26 00:40:38  tom
// Initial revision
//
//======================================================================
