/* -*-C-*-
*******************************************************************************
*
* File:         mailapp.h
* RCS:          /Users/tom/Work/WMInspectors/MailboxInspector-0.9/RCS/mailapp.h,v 1.1 1996/03/29 16:25:05 tom Exp
* Description:  Structures for Mail.app mailboxes
* Author:       Carl Edman
* Created:      Sun Apr 25 10:25:29 1993
* Modified:     Tue Mar 12 21:24:47 1996 (Carl Edman) cedman@capitalist.princeton.edu
* Language:     C
* Package:      N/A
* Status:       Experimental (Do Not Distribute)
*
* (C) Copyright 1993, but otherwise this file is perfect freeware.
*
*******************************************************************************
*/

#import <appkit/appkit.h>

/* The following two structures have been stolen from Chris Paris excellent
   exposition of the NeXT mailbox format */

struct table_of_contents_header
   {
   int magic;          /* magic number: 890712 */
   int num_msgs;       /* number of messages in mbox */
   time_t mbox_time;    /* the m_time of mbox */
   NXCoord list;        /* height of upper section of split view containing list */
   NXRect window;       /* Mail window */
   } toch;

struct message_index
   {
   int record_length;  /* the length of this record, including this word */
   int mes_offset;     /* offset in mbox where this message begins */
   int mes_length;     /* length in bytes of this message in mbox */
   int mes_date;       /* the date of this message */
   char status;         /* read ' ', unread '*', deleted 'd' or 'D', flagged '+' */
   char msgtype;        /* regular ' ', NeXT mail 'r' or Mime Mail 'm' */
   char encrypted;      /* Is this message encrypted ? */
   char sync;           /* always ' ' */
   char data[0];
   } *mi;
