/* -*-C-*-
*******************************************************************************
*
* File:         mailutil.h
* RCS:          /Users/tom/Work/WMInspectors/MailboxInspector-0.9/RCS/mailutil.h,v 1.1 1996/03/29 16:25:06 tom Exp
* Description:  Header file for all Mail.app utilities
* Author:       Carl Edman
* Created:      Sun Apr 25 10:27:09 1993
* Modified:     Fri Mar 29 10:33:21 1996 (Carl Edman) cedman@capitalist.princeton.edu
* Language:     C
* Package:      N/A
* Status:       Experimental (Do Not Distribute)
*
* (C) Copyright 1993, but otherwise this file is perfect freeware.
*
*******************************************************************************
*/

#import <time.h>
#import "mailapp.h"

#define LINELEN 1024

extern int getopt(int ac,char *av[],char *opts);
extern int optind;
extern char *optarg;

int mailboxdir(char *buf);
int cd_mbox(const char *name,int createflag);
int uncd_mbox(void);
int lock_mbox(int nowaitflg);
int unlock_mbox(void);

time_t mtime(const char *path);
off_t filesize(const char *path);
int dirsize(char *path);

struct table_of_contents_header *get_table_of_contents_header(int fd,int createflag);
struct message_index *get_message_index(int fd);

char *message_from(const struct message_index *mi);
char *message_subject(const struct message_index *mi);
char *message_reference(const struct message_index *mi);

int message_attachsize(const struct message_index *mi);
time_t message_attachtime(const struct message_index *mi);
int message_priority(const struct message_index *mi);

int message_set_attachsize(struct message_index *mi,int size);
time_t message_set_attachtime(struct message_index *mi,time_t time);
int message_set_priority(struct message_index *mi,int priority);

long message_current_date(void);
long message_date(int year,const char *month,int day);

int message_age(const struct message_index *mi);

int put_message_index(int fd,struct message_index *mi);
int put_table_of_contents_header(int fd,struct table_of_contents_header *toc);

char *strpcpy(char *to,const char *beg,const char *end);
char *strpcat(char *to,const char *beg,const char *end);
int strpequ(char *to,const char *beg,const char *end);
int strpcaseequ(char *to,const char *beg,const char *end);

void appstring(char **string,int *len,int *maxlen,const char *app,const int alen);
char *growstring(char **string,int *len,int *maxlen,const int alen);

unsigned long int calc_crc(const char *beg,int len);

void forall_mboxes(void (*func)(const char *));
