#import <objc/NXBundle.h>
#import <appkit/Application.h>

#import "NLoadCommon.h"

#define VERSION __DATE__

@interface NLoad : Application
{ 
	id localUpdateSlider;
	id localUpdateTextField;
	id remoteUpdateSlider;
	id remoteUpdateTextField;
	id shiftDisplaySlider;
	id shiftDisplayTextField;
	
	id q1ColorWell;
	id q5ColorWell;
	id q15ColorWell;
	
	id colorWells[QUEUES];
	
	id backgroundColorWell;
	id quiescentColorWell;
	id divisionColorWell;
	
	id queueSwitchMatrix;
	
	id helpPopUpList;
	id helpScrollView;
	
	id version;
	
	NXSize size;
	NXBundle *bundle;
	BOOL which[QUEUES];
	id defaults, panel;
	NXPoint origin, location, increment;
}

+ new;

- appDidInit:sender;
- appWillTerminate:sender;
- app:sender powerOffIn:(int) ms andSave:(int) aFlag;

- setDefault:sender;
- setMatrixDefault:sender;

- setLocalUpdate:sender;
- setRemoteUpdate:sender;
- setDisplayShift:sender;

- addHost:(const char *) string;
- addNIHost:sender;

- initializeView:aView;

- setHelpPopUpList:anObject;
- displayHelp:sender;
- displayHelpWindow:sender;

- setQ1ColorWell:anObject;
- setQ5ColorWell:anObject;
- setQ15ColorWell:anObject;

- setDivisionColorWell:anObject;
- setBackgroundColorWell:anObject;
- setQuiescentColorWell:anObject;

- setLocalUpdateSlider:anObject;
- setLocalUpdateTextField:anObject;
- setRemoteUpdateSlider:anObject;
- setRemoteUpdateTextField:anObject;
- setShiftDisplaySlider:anObject;
- setShiftDisplayTextField:anObject;

- changeQueues:sender;

- setVersion:anObject;

@end
