#import <appkit/ScrollView.h>
#import <objc/HashTable.h>
#import <objc/List.h>

@interface NibFile:ScrollView
{
    id	mainText;
    id	runData;
    id	connects;
    id	objects;
    id	nibDataInst;
    id	sounds;
    id	table;
    id	icons;
	
	HashTable *nameByObj;
	HashTable *treeByObj;
	HashTable *connByObj;
	List	*tree;
	
	int	numTabs;
}

/* House-keeping funtions */
- initFrame:(const NXRect *)frameRect;
- makeEnclosingWindow:(const NXRect *)rect;
- newText:(const NXRect *)frameRect;

/* Printout process starts here */
- initFile:(const char *)fileName;

/* Delegate methods from window */
- windowWillClose:sender;

/* Utility methods for printing whole objects */
- dumpObj:target;
- dumpRootObj:target;

/* Utility methods for displaying data */
- print:(const char *)output;
- print:(const char *)output withFlush:(BOOL)flag;
- printTab:(const char *)output;
- enTab;
- unTab;

/* Main logic */
- buildHash;
- summarizeObj:target;
- dumpNibObjectFromTree:target;
- dumpNibConnectionsforObject:anObject;

@end
