/*****************************************************************************
 *
 *	Help.h
 *	
 *	Author:		Denise Howard (not really) Julie Zelenski
 *	
 *	Desc:		This is a stripped down version of the Help object from
 *				the NeXT BusyBox example code.
 *					
 *****************************************************************************/

#import <appkit/appkit.h>
#import <appkit/appkit.h>
#import <sys/dir.h> //for getdirentries()

#define CHUNK 127

@interface Help:Object
{
    id helpScrollView;					/* scrollView to put help text in */
    id helpBrowser;						/* NXBrowser of help topics */
    id helpPanel;						/* the help panel */
    char helpDirectory[MAXPATHLEN+1];	/* the directory to find help files */
    char noHelpFile[MAXPATHLEN+1];		/* the name of the "no help" file */
}

/* MAKE ONLY ONE GLOBAL INSTANCE */

+ new;

/* INIT/FREE METHODS */
- init;

/* TARGET/ACTION METHODS */
- generalHelp:sender;
- browserHit:sender;

/* HELP METHODS */
- showHelpFile:(const char*)filename;

/* BROWSER DELEGATE METHODS */
- (int)browser:sender fillMatrix:matrix inColumn:(int)column;
- browser:sender loadCell:cell atRow:(int)row inColumn:(int)column;
- (BOOL)browser:sender selectCell:(const char *)title inColumn:(int)column;

@end



