#import "ColorViewer.h"

@implementation ColorViewer:PBView


- initPBView:sender
{
    [super initPBView:sender];
    [self readIconFrom:"color.tiff" forType:NXColorPboardType];

    return self;
}

// List item Types this PBView object can handle;
- (char **)canHandle
{
    static const char *itemTypes[]={ NULL, NULL }; 
    
    itemTypes[0] = NXColorPboardType;
    
    return itemTypes;
}


- activateForType:(const char *)type inFrame:(NXRect *)rect
{
    NXColor col;
    float r,g,b,a;
    NXStream *str;
    int start;

    doc = [[Text alloc] initFrame:rect];
    [doc setFont:[Font newFont:"Courier" size:12.0]];
    [doc setEditable:NO];
    [doc setMonoFont:NO];
    col = NXReadColorFromPasteboard([controller getPb]);
    str = NXOpenMemory(NULL, 0, NX_READWRITE);
    NXPrintf(str,"Color Information:\n");
    NXConvertColorToRGBA(col, &r, &g, &b, &a);
    NXPrintf(str,"Red:       %f\n", r);
    NXPrintf(str,"Green:     %f\n", g);
    NXPrintf(str,"Blue:      %f\n", b);
    NXPrintf(str,"Alpha:     %f\n", a);
    NXPrintf(str,"Name:      %s\n", NXColorName(col));
    
    NXSeek(str, 0, NX_FROMSTART);
    [doc readText:str];
    NXCloseMemory(str, NX_FREEBUFFER);
    start = [doc textLength];
    [doc setSel:[doc textLength] :[doc textLength]];
    [doc replaceSel:"abcdefghijklmnopqrstuvwxyz\nABCDEFGHIJKLMNOPQRSTUVWXYZ\n0123456789\n"];
    [doc setSel:start :[doc textLength]];

    [doc setSelColor:col];
    [doc setSel:0 :0];

    [doc calcLine];
    [doc setHorizResizable:YES];
    [doc setVertResizable:YES];
    [doc sizeToFit];


    return doc;
}

- deactivateView
{
    [doc free];
    return self;
}

@end











