
#import <appkit/appkit.h>

// ***************************************************
// General PasteboardView
// ***************************************************
@interface PBView:View
{
    id controller;
    id iconlist;
}

// initialize the Pasteboard View. sender will be the controller
- initPBView:sender;

// return the controller instance variable
- getController;

// main entry point. This function will be called whenever there is
// a type for this viewer on the pasteboard and the user wants to 
// see what exactly this type is.
// "type" will be one of the types u specified in "canHandle". "rect"
// will be the initial rect in the ScrollView of Pastebaord Inspector
// This method has to return a valid view! The view will be installed
// in the ScrollView.
- activateForType:(const char *)type inFrame:(NXRect *)rect;

// view is deactivated. Remove temporary view returned in activateForType
// and clean up, but dont free yourself!
- deactivateView;

// array of char * for the types handled by this viewer
- (char **)canHandle;

// read an Icon for a certain type of Pasteboard content. Filename 
// has to be a single filename with no directories added to it. 
// Pasteboard Inspector will look in the main bundle for the icon.
- readIconFrom:(const char *)filename forType:(const char *)theType;

// returns the Icon for a specific type. This is one of the Icons
// you installed with readIconFrom:forType:
- getIconForType:(const char *)theType;

// This message is passed to the viewer after a activate:inFrame: method
// when the view has been announced to the ScrollView. You can do some
// more initialisation.
- viewInstalled;

// This method is called short before the view gets a deactivateView.
// Your view is still in the ScrollView. 
- viewWillBeUninstalled;
@end







