//
// Time-stamp: <95/12/08 22:01:54 stephan>
//
// RulerControl.h
// Project: Rulers
//
// Stephan Wacker
// 93-01-31


#import <appkit/appkit.h>

@interface RulerControl:Object
{
    id		view;			// RulerView
    id		window;			// Panel
    id		controlBox;		// Box
    id		controlBoxBackground;	// Button
    id		knob;			// Button

    NXImage	*knobImage[2];		// normal, highlighted
    
    int		myId;			// unique number
    
    int		unitsSystem;		// preferences settings
    int		inchMode;
    BOOL	displayLabels;
    BOOL	floatAboveWindows;
    BOOL	hideWhenDeactivated;
    int		posNumDirection;
    NXColor	color;
    NXColor	marksColor;
    
    BOOL	rulerWasDragged;
}

// initialization
- awakeFromNib;

// access: read
- (int) unitsMode;
#if 0
- (int) screenMode;
#else
- (float) screenDpi;
#endif
- (int) inchMode;
- (BOOL) labelsMode;
- (BOOL) floatMode;
- (BOOL) hideMode;
- (NXColor) color;
- (NXColor) marksColor;
- window;

// access: write
- setColor: (NXColor) color;

// actions
- drag: sender;

// control
- resize: (SEL) action;
- applyPreferences: sender;
- takePreferencesFrom: sender;
- keyDown: (NXEvent *) theEvent;

// support
- makeColoredImage: (NXImage **) canvas
  shape: (const char *) shapeName
  mask: (const char *) maskName;

@end

// Constants for keys in Symbol character set
//
#define KEY_UP			0xAD
#define KEY_DOWN		0xAF
#define KEY_LEFT		0xAC
#define KEY_RIGHT		0xAE
