//
// Time-stamp: <95/12/08 21:58:03 stephan>
//
// RulerPreferencesControl.h
// Project: Rulers
//
// Stephan Wacker
// 93-01-31


#import <appkit/appkit.h>
#import "RulerPreferences.h"

@interface RulerPreferencesControl:Object
{
    id		window;			// Panel
    id		screenSizePanel;	// Panel
    id		rulerControl;		// RulerControl

    id		applyButton;		// ButtonCell
    id		applyAllButton;		// ButtonCell
    id		saveButton;		// ButtonCell

    id		unitsMatrix;		// Matrix of Radio Buttons
#define UNIT_DEFAULT_NAME	"Units"
// "pica", "inch", "cm", "true in", "true cm"
#define UNIT_DEFAULT_VALUE	"cm"
#define UNIT_DEFAULT		UNIT_CM

#if 0
#
    id		screenMatrix;		// Matrix of Radio Buttons
#define SCREEN_DEFAULT_NAME	"Screen"
// "17", "21"
#define SCREEN_DEFAULT_VALUE	"17"
#define SCREEN_DEFAULT		XVII_INCH
#
#else
#
    id		dpiField;
#define DPI_DEFAULT_NAME	"ScreenDPI"
// <double>
#define DPI_DEFAULT_VALUE	"92.0"
#define DPI_DEFAULT		92.0
#
#endif

    id		inchMatrix;		// Matrix of Radio Buttons
#define INCH_DEFAULT_NAME	"InchDiv"
// "8", "10"
#define INCH_DEFAULT_VALUE	"8"
#define INCH_DEFAULT		INCH_DIV_8

    id		hMarksMatrix;		// Matrix of Radio Buttons
#define HMARKS_DEFAULT_NAME	"HorizontalMarks"
// "Top", "Bottom", "Both"
#define HMARKS_DEFAULT_VALUE	"Bottom"
#define HMARKS_DEFAULT		HMARKS_BOTTOM

    id		vMarksMatrix;		// Matrix of Radio Buttons
#define VMARKS_DEFAULT_NAME	"VerticalMarks"
// "Left", "Right", "Both"
#define VMARKS_DEFAULT_VALUE	"Right"
#define VMARKS_DEFAULT		VMARKS_RIGHT

    id		hNumberMatrix;		// Matrix of Radio Buttons
#define HPOSNUM_DEFAULT_NAME	"HorizontalPositiveNumbers"
// "Left", "Right", "Both"
#define HPOSNUM_DEFAULT_VALUE	"Right"
#define HPOSNUM_DEFAULT		POSNUM_RIGHT

    id		vNumberMatrix;		// Matrix of Radio Buttons
#define VPOSNUM_DEFAULT_NAME	"VerticalPositiveNumbers"
// "Up", "Down", "Both"
#define VPOSNUM_DEFAULT_VALUE	"Down"
#define VPOSNUM_DEFAULT		POSNUM_DOWN

    id		labelsButton;		// Button; BOOL
#define LABELS_DEFAULT_NAME	"LabelNumbers"
// "YES", "NO"
#define LABELS_DEFAULT_VALUE	"YES"
#define LABELS_DEFAULT		YES

    id		floatButtonCell;	// ButtonCell; BOOL
#define FLOAT_DEFAULT_NAME	"FloatAboveWindows"
// "YES", "NO"
#define FLOAT_DEFAULT_VALUE	"NO"
#define FLOAT_DEFAULT		NO

    id		hideButtonCell;		// ButtonCell; BOOL
#define HIDE_DEFAULT_NAME	"HideWhenDeactivated"
// "YES", "NO"
#define HIDE_DEFAULT_VALUE	"NO"
#define HIDE_DEFAULT		NO

    id		colorCell;		// ColorCell;
#define COLOR_DEFAULT_NAME	"Color"
// "%f %f %f"
#define COLOR_DEFAULT_VALUE	"0.6 0.4 0.2"
#define COLOR_DEFAULT		parseColor( COLOR_DEFAULT_VALUE )
#define COLOR_FORMAT		"%f %f %f"

}



// initialization
- awakeFromNib;

// defaults
+ (int) defaultUnitsMode;
#if 0
+ (int) defaultScreenMode;
#else
+ (float) defaultScreenDpi;
#endif
+ (int) defaultInchMode;
+ (int) defaultHMarksMode;
+ (int) defaultVMarksMode;
+ (BOOL) defaultLabelsMode;
+ (BOOL) defaultFloatMode;
+ (BOOL) defaultHideMode;
+ (int) defaultHPosNumMode;
+ (int) defaultVPosNumMode;
+ (NXColor) defaultColor;

// access
- (int) unitsMode;
#if 0
- (int) screenMode;
#else
- (float) screenDpi;
#endif
- (int) inchMode;
- (int) vMarksMode;
- (BOOL) labelsMode;
- (BOOL) floatMode;
- (BOOL) hideMode;
- (int) hPosNumMode;
- (int) vPosNumMode;
- (NXColor) color;

// actions
- apply: sender;
- applyAll: sender;
- cancel: sender;
- ok: sender;
- save: sender;
- revert: sender;

// control
- takePreferencesFrom: sender;

@end
