//
//	DriveSCSI_Class - subclass of SCSI2_Class for disk drive devices
//
//	Copyright (C) 1994 by Christopher Wolf.
//
//	This library is free software; you can redistribute it and/or
//	modify it under the terms of the GNU Library General Public
//	License as published by the Free Software Foundation; either
//	version 2 of the License, or (at your option) any later version.
//
//	This library is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//	Library General Public License for more details.
//
//	You should have received a copy of the GNU Library General Public
//	License along with this library; if not, write to the Free
//	Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
//	Bug-reports, comments and questions should be directed to:
//		Christopher Wolf <chris@alchemy.geo.cornell.edu>
//
//	Portions of this code and documentation are derived from an 
//	earlier work (SCSI Inquirer) Copyright (C) 1990, 1991, 1992 by 
//	Jiro Nakamura and used with permission.
//

//
// 	For best results view this file with a tab size of 4 and
//	a display width of 132 columns or wider.
//

//	file version information
#define RCSDSH "$Id: DriveSCSI.h,v 0.24 94/09/06 00:29:10 chris Exp Locker: chris $"

//	SCSI2 class specific headers
#import "SCSI.h"

@interface DriveSCSI:SCSI
	{
	}
	
// sub-class responsibility
- (BOOL) isDevice;	

// pre-packaged commands
- (int) formatUnit;
- (int) seekExtendedTo: (u_int)logicalBlockAddress;
- (int) readExtendedFrom: (u_int)lba to: (char *)destBuffer numBytes: (u_int)numBytes numBlocks: (u_int)numBlocks; 
	
@end
