/***(PanelManager.m)***********************************************************
*H* SciCalc Panel Manager object class implmentation          V0.0, 19-JUN-91 *
*C* V0.0 19-JUN-91 Initial version  	    	    	    	    	--MDM *
******************************************************************************/

#import "PanelManager.h"
#import "HelpWindow.h"
#import "InfoWindow.h"

@implementation PanelManager


/******************************************************************************
* INSTANCE METHOD:- init    	    	    	    	    	    	      *
*   Intialize the intance variables 	    	    	    	    	      *
******************************************************************************/
- init

{/* BEGIN:-init */
self = [super init];

IVhelpPanel = nil;
IVinfoPanel = nil;
return self;
}/* END init */



/******************************************************************************
* INSTANCE METHOD:- ShowHelpPanel      	    	    	    	    	      *
*   This method is called  when the Help  item is selected from the Info sub- *
* menu.  On the first  entry  this  routine  creates  the help panel and then *
* subsequently it just brings the panel to the foreground.	    	      *
******************************************************************************/
- ShowHelpPanel:sender

{/* BEGIN ShowHelpPanel */
if ( IVhelpPanel == nil )
    /* This is the first entry to this method, unarchive the help panel */
    IVhelpPanel = [[HelpWindow alloc] init];

/* Move the help panel to the top of the window stack and give it focus */
[IVhelpPanel ExposeAndFocus:self];
return self;
}/* END ShowHelpPanel */



/******************************************************************************
* METHOD:- ShowInfoPanel    	    	    	    	    	    	      *
*   This method is called when  the  Info item is selected from the Info sub- *
* menu.  On the first  entry  this  routine  creates  the help panel and then *
* subsequently just brings the panel to the foreground.	    	      	      *
******************************************************************************/
- ShowInfoPanel:sender

{/* BEGIN ShowInfoPanel */
if ( IVinfoPanel == nil )
    /* This is the first entry to this method, unarchive the info panel */
    IVinfoPanel = [[InfoWindow alloc] init];

/* Move the help panel to the top of the window stack and give it focus */
[IVinfoPanel ExposeAndFocus:self];
return self;
}/* END ShowInfoPanel */

@end
