
#import <appkit/View.h>
#import "Thinker.h"

typedef struct { float l,b,r,t;	} BRECT;

@interface SlideShowView:View
{
	float	xpos;
	float	ypos;

	BRECT	old;
	NXPoint	imageTo;
	NXPoint	maxCoord;
	NXPoint	redrawTo;
	NXRect	redraw;
	NXSize	oldSize;
	
	id	buffer;

	int	numberOfFrames;
	int	currentFrame;
	id	imageList;
	id	currentImage;
	NXSize	maxImageSize;
	NXSize	currentImageSize;

	BStimeval	now, then;
	BStimeval	nextRotationTime;

	id	inspectorView;
	
	BOOL	bounce; 
	int	secsPerSlide;
	char	*ssslidesPath;

	id 	bounceButton;
	id	pathButton;
	id	pathTextField;
	id	secsPerSlideSlider;
	id	secsPerSlideTextField;
}

- oneStep;
- readSlidesFromFile:(const char *)slidesPath;
- sizeTo:(NXCoord)width :(NXCoord)height;
- drawSelf:(const NXRect *)rects :(int)rectCount;
- newViewSize;
- incrementImageNumber;
- (const char *)windowTitle;

- bounceButtonHit:sender;
- setSecsPerSlide:sender;
- pathButtonHit:sender;
- pathSet:sender;

@end
