#import <appkit/View.h>

#define NSTARS (200)
#define STARSPERIT (100)

typedef struct STAR {
	float theta; // angle
	float distance;
	float delta; // change in distance
	float ddelta; // change in delta, a constant multiplier

	char c;

	int changemode;
	float changepoint[6];

	NXPoint r1, r2;
	NXPoint *draw;
	NXPoint *erase;

	} STAR;

@interface SpaceView:View
{
	STAR stars[NSTARS];
	int nstars;
	int radius; // min radius of this view

	NXPoint b[NSTARS];
	NXPoint bOffsets[NSTARS];
	char bc [NSTARS+1];

	NXPoint w[NSTARS];
	NXPoint wOffsets[NSTARS];
	char wc [NSTARS+1];

	NXRect voidRect; // avoid the void!
	int toggle;
	NXSize oldSize;
}

- convertToXY:(STAR *) p;
- oneStep;
- (BOOL) allowStars:(const STAR *) p;
- initFrame:(const NXRect *) frameRect;
- drawSelf:(const NXRect *) rects :(int) rectCount;
- sizeTo:(NXCoord) width :(NXCoord ) height;
- addStar;
- replaceStarAt:(int) index;
- setRadius;
- (const char *) windowTitle;
- setVoidRect:(const NXRect *) r;
- didLockFocus;
- (BOOL) useBufferedWindow;
- (BOOL) ignoreMouseMovement;

@end

@interface View(nonretainedFillMethod)

- fillBoundsWithBlack;

@end
