#import <appkit/View.h>
#import <appkit/Application.h>
#import <dpsclient/dpsNeXT.h>
#import <sys/resource.h>
#import <drivers/event_status_driver.h>

#import "ModuleList.h"

#define SAVERTIER (50)

typedef unsigned BStimeval;

// a function to return BackSpace's Thinker instance or it's equivalent
id BSThinker();

BStimeval currentTimeInMs();

float frandom(), randBetween(float a, float b);

// Forced to make SpaceSaver instance variables conform to those
// of Thinker since some modules grab internals directly -- sigh.

@interface SpaceSaver:Object
{
	id spaceView;

	id spaceWindow;
	id normalWindow; // not used
	id bigUnbufferedWindow;
	id bigBufferedWindow;

	BOOL timerValid;
	BOOL keepLooping; // not used
	BOOL doingSaver;
	DPSTimedEntry timer;

	int windowType; // not used
	int realViewIndex;
	int virtualViewIndex;
	NXRect windowRect; // not used

	NXZone *backZone;

	int screenCount;
	id windMatrix; // not used

	id screenSaver; // not used
	id screenLocker; // not used
	BOOL screenSaverVal;
	id mySlider; // not used

	id priorityLevel; // not used
	int priority;

	NXEventHandle evs; // not used
	double dimBrightness; // not used
	double normalBrightness; // not used

	id viewSelectionBrowser; // not used
	ModuleList *moduleList;
	id imageView; // not used
	NXScreen *screens;
	id screenList;

	id image;
	int globalTier; // not used

	id password; // not used

	id invisibleInspectorBox; // not used
	id commonImageInspector;
	id nullInspector;
	id spaceInspector; // not used
	id boinkInspector; // not used
	id currentInspector;
	NXRect inspectorFrame; // not used
	id oldInspectorOwner; // not used
	BOOL browserValid; // not used
	id infoPanel; // not used

	char *fileToOpen; // not used
	BOOL openAnother; // not used

	int windowHasBeenDisplayed; // not used
	id sleepWindow; // not used
	id cornerView; // not used
}

+ alloc;

#ifdef DEBUG
- startScreenSaver:sender;
- stopScreenSaver:sender;
#endif
- startScreenSaver;
- stopScreenSaver;
- step;

- createScreenSaver;
- init;
- free;

- borrowDefaults:(const char *) realOwner;

- (NXZone *) backZone;
- (ModuleList *) moduleList;

- createTimer;
- removeTimer;

- installSpaceViewIntoWindow;
- (int) backingTypeForView:aView;
- createBigWindowIfNecessaryForBacking:(int) backing;

- setScreenSaver:(BOOL) val;

- getPrioritySetting;

- setImageFromName:(const char *) name;
- setImageFromFile:(const char *) filename;
- commonImageInit;
- getImageFile;

- getViewType;
- setVirtualViewIndex;
- selectScreenSaverViews;

- backView;
- loadViewsFrom:(const char *) dirname;
- (const char *) appDirectory;
- (const char *) moduleDirectory:(const char *) name;
- (struct mach_header *) headerForModule:(const char *) name;

- blackOutAllScreens;
- unBlackOutAllScreens;

- nullInspector;
- commonImageInspector;

@end

@interface View(someOptionalMethods)

- oneStep;
- newWindow;
- didLockFocus;

- enteredScreenSaverMode;
- willExitScreenSaverMode;

- inspector:sender;
- inspectorWillBeRemoved;
- inspectorInstalled;

- (BOOL) useBufferedWindow;
- (BOOL) ignoreMouseMovement;
- (BOOL) isBoringScreenSaver;

- (const char *) windowTitle;

@end
