#import <appkit/appkit.h>
#import <sys/dir.h> //for getdirentries()
#import <mach/mach.h>
#import <mach/message.h>
#import <soundkit/Sound.h>
#import "StarShipProtocol.h"



@interface StarShipView:View
{

	NXRect smallScreenRect;
	NXRect newViewScreenSize;


	id				viewScreen;
	id				shipWindow;
	const char		*moduleDir;
	port_t			*port;
	long			frameRate;
	
	BOOL			viewScreenResized; 	//set by NewSpaceView
	BOOL 			soundEnabled;
	BOOL			soundGood;
	BOOL			firstTimeSound;	//don't play sound on startup
	BOOL			soundDelay;
	Sound			*pwrDownSnd;
	Sound			*pwrUpSnd;
	Sound			*sound;
	List			*controllerList;   //list of space object controllers
	id 				spaceTypeController;  	//current controller
	unsigned int	controllerIndex;		//current controller index
	unsigned int	controllerTypeCount; 	//total controller count
	NXRect 			*rectPtr,clipRect;		//for setting clipping

	id				inspectorPanel;
	id				starSpeedSlider;
	id				animationSlider;
	id				objectSpeedSlider;
	id				objectIntervalSlider;
	id				cycleCountSlider;
	id				cycleCountBox;
	id				soundMatrix;
	id				infoText;
	id				moduleBox;
}

- buildControllerList:(char *)directory;   // build list of space object types

- (int)searchDirectory: (char *)directory;


// I never implemented this but if someone wanted to
// let me know
//- mouseDown:(NXEvent *)theEvent;


- (const char *) windowTitle;

- inspector:sender;
- inspectorWillBeRemoved;

- (BOOL)makeSndObjects: (char *)directory;
- setAnimationSpeed:(Slider *)sender;
- setObjectSpeed:(Slider *)sender;
- setObjectInterval:(Slider *)sender;
- setCycleCount:(Slider *)sender;
- setStarSpeed:(Slider *)sender;
- setSound:sender;
- setModuleBox;


port_t *xmach_sleep_install(void);
void xmach_sleep_remove(port_t *);
void xmach_sleep(port_t *, msg_timeout_t);

- inspector:sender;
- viewScreenResized:(NXRect *)screenRect;

- delayedDefaults:sender;
- getDefaults:sender;
- writeDefaults:sender;

@end

