/* by Erik Sowa <sowa@netcom.com>.   Public domain. */

#include <stdio.h>
#include <time.h>

typedef double debt_t, pop_t;
extern debt_t national_scb89debt_at();
extern debt_t national_aj92debt_at();
extern pop_t national_pop_at();
extern void debt_to_string();

void main(argc, argv)
     int argc;
     char **argv;
{
  char debtbuf[255], sharebuf[255];
  time_t now;
  debt_t scb89debt, aj92debt;
  pop_t pop;
  
  now = time ((time_t*) 0);
  scb89debt = national_scb89debt_at(now);
  aj92debt = national_aj92debt_at(now);
  pop = national_pop_at(now);
  
  printf("Estimates of current U.S. National Debt:\n");

  debt_to_string(scb89debt, debtbuf);
  debt_to_string(scb89debt/pop, sharebuf);
  printf("Survey of Current Business (1989) estimate: $%s.\n Your share: $%s.\n",debtbuf,sharebuf);

  debt_to_string(aj92debt, debtbuf);
  debt_to_string(aj92debt/pop, sharebuf);
  printf("Albuquerque Journal (1992) estimate:        $%s.\n Your share: $%s.\n",debtbuf,sharebuf);
}
