/***(VdtApplication.h)*********************************************************
*H* Virtual Desk Top Application subclass interface 	       V0.3 08-MAY-92 *
******************************************************************************/


#import <appkit/Application.h>

#define VdtKdefSetBottomLeft    "BottomLeft"
#define VdtKdefSetBottomRight	"BottomRight"
#define VdtKdefSetDeferred  	"Deferred"
#define VdtKdefSetDock	 	"Dock"
#define VdtKdefSetFloating    	"Floating"
#define VdtKdefSetMainMenu    	"MainMenu"
#define VdtKdefSetNo	    	"No"
#define VdtKdefSetNormal    	"Normal"
#define VdtKdefSetImmediate 	"Immediate"
#define VdtKdefSetSlippery 	"Slippery"
#define VdtKdefSetSticky 	"Sticky"
#define VdtKdefSetSubMenu    	"SubMenu"
#define VdtKdefSetTopLeft    	"TopLeft"
#define VdtKdefSetTopRight    	"TopRight"
#define VdtKdefSetYes	    	"Yes"

#define VdtKdefNamBorderGray	"BorderGray"
#define VdtKdefValBorderGray	"0.0"
#define VdtKdefNamDockHandling	"DockHandling"
#define VdtKdefValDockHandling	VdtKdefSetSticky
#define	VdtKdefNamIconGravity  	"IconGravity"
#define	VdtKdefValIconGravity  	VdtKdefSetBottomLeft
#define	VdtKdefNamImmobile  	"Immobile"
#define VdtKdefValImmobile  	VdtKdefSetNo
#define VdtKdefNamOrigin    	"Origin"
#define VdtKdefValOrigin    	"0 0"
#define VdtKdefNamPanDelta      "PanDelta"
#define VdtKdefValPanDelta      "100"
#define VdtKdefNamPanGrid       "PanGrid"
#define VdtKdefValPanGrid       "0"
#define VdtKdefNamPanJump       "PanJump"
#define VdtKdefValPanJump       VdtKdefSetNo
#define VdtKdefNamResizeBar     "ResizeBar"
#define VdtKdefValResizeBar     VdtKdefSetYes
#define VdtKdefNamScale         "Scale"
#define VdtKdefValScale         "8"
#define VdtKdefNamSize          "Size"
#define VdtKdefValSize          "2 2"
#define VdtKdefNamWinLocX       "WinLocX"
#define VdtKdefValWinLocX       "300"
#define VdtKdefNamWinLocY       "WinLocY"
#define VdtKdefValWinLocY       "300"
#define VdtKdefNamWindowLevel   "WindowLevel"
#define VdtKdefValWindowLevel   VdtKdefSetFloating
#define VdtKdefNamWindowMotion  "WindowMotion"
#define VdtKdefValWindowMotion  VdtKdefSetDeferred

@interface VdtApplication:Application

{
id	IVvdtWindow;	/* NIB Outlet: object ID of the VdtWindow */
id 	IVvdtView;  	/* NIB Outlet: object ID of the VdtView */
}

- getDefaultBorderGray:(float*)grayValue;
- getDefaultDockHandling:(int*)dockHandling;
- getDefaultIconGravity:(int*)gravity;
- getDefaultImmobile:(int*)immobile;
- getDefaultOrigin:(int*)xPos :(int*)yPos;
- getDefaultPanDelta:(int*)panDelta;
- getDefaultPanGrid:(int*)panGrid;
- getDefaultPanJump:(int*)panJump;
- getDefaultResizeBar:(int*)resizeBar;
- getDefaultScale:(float*)scale;
- getDefaultSize:(int*)width :(int*)height;
- getDefaultWinLoc:(int*)locX :(int*)locY;
- getDefaultWindowLevel:(int*)level;
- getDefaultWindowMotion:(int*)motion;
- getVdtWindow;
- getVdtView;
- registerAppDefaults;
- validateAppDefaults;

@end
