/***(VdtView.h)****************************************************************
*H* Virtual Desk Top View subclass interface specification  	    	      *
******************************************************************************/

#import <appkit/View.h>

typedef struct CSwinInfo
    {
    int	    number;
    int	    context;
    int	    level;
    char    sticky;
    NXRect  actualRect;
    NXRect  scaledRect;
    } CTwinInfo;


@interface VdtView:View

{/* Instance Variables */
int 	    IVdockHandling;    	/* Is Dock Handling Sticky or Slippery */
NXSize      IVscreenSize;   	/* Physical screen width&height in pixels */
int 	    IVstickyCount;  	/* Number of valid entries in sticky table */
int 	    IVstickySize;   	/* Number of elements in the sticky table */
int 	   *IVstickyTable;  	/* Pointer to sticky window table */
NXSize      IVvdtActualSize;    /* Virtual Desk Top View width&height in pixels */
NXPoint	    IVvdtOrigin;   	/* Virtual Desk Top View Port Origin */
NXPoint	    IVvdtPanGrid;    	/* Pan Grid X and Y increments */
int 	    IVvdtPanJump;    	/* Should view port jump to mouse click */
int 	    IVvdtRootWinNum;   	/* Global window number of root window */
float       IVvdtScale;	    	/* Scaling factor from screen dimensions to Actual VDT size */
id  	    IVvdtStillImage;	/* Stationary Image for moving VDT objects */
NXSize      IVvdtVirtualSize;   /* Virtual Desk Top width&height in pixels */
int 	    IVvdtWinNum;    	/* Global window number of main VDT window */
NXRect      IVviewPort;     	/* Visible screen view port rectangle */
int 	    IVwindowMotion; 	/* Flag for Deffered or Immediate window motion */
CTwinInfo  *IVwinInfoList;   	/* List of on screen windows in VDT */
int 	    IVwinInfoCount; 	/* Length of IVwinInfoList */
}


- alignIcons:sender;
- dragVdtViewPort:(NXPoint*)startPos :(int)checkMask;
- dragVdtWindow:(NXPoint*)startPos :(int)checkMask;
- drawSelf:(const NXRect*)rects :(int)rectCount;
- initFrame:(const NXRect*)frameRect;	
- mouseDown:(NXEvent*)eventPtr;
- moveViewPortAbs:(float)newX :(float)newY;
- moveViewPortRel:(float)deltaX :(float)deltaY;
- renderVdt:(int)outWin;
- retrieveDock:sender;
- returnDock:sender;
- setVdtPanGrid:(int)panGrid;
- setVdtPanJump:(int)panJump;
- setVdtWindowNumber:(int)windowNum;
- setViewDockHandling:(int)tagValue;
- setViewWindowMotion:(int)tagValue;
- sizeTo:(NXCoord)width :(NXCoord)height;
- stickyListAdd:(int)windowNum;
- stickyListDelete:(int)windowNum;
- stickyListPurge;
- updateVdtView:sender;
- updateWindowList;
- Test_1:sender;
- Test_2:sender;

@end
