/***(VdtWindow.h)**************************************************************
*H* Virtual Desk Top Window subclass interface specification  	    	      *
******************************************************************************/

#import <appkit/Window.h>

@interface VdtWindow:Window

{/* Instance Variables */
float	IVborderGray;	    /* Gray Value of border highlight */
int 	IVglobalWinNum;	    /* DPS server window number for this window */
int 	IVisVdtImmobile;    /* Is the Vdt Window immobilized */
float	IVpanDeltaX;	    /* Horizontal VDT view port panning delta */
float	IVpanDeltaY;	    /* Veritcal VDT view port panning delta */
int 	IVselectedTag;	    /* Tag to simulate menu cell sender */
id  	IVvdtView;  	    /* VDT drawing View */
NXPoint	IVvdtOrigin;        /* The VDT View Port Origin in VDT coords */
NXRect 	IVvdtRect;          /* The Virtual Rectangle of the VDT */
float	IVvdtScale;	    /* Scaling factor from virtual to VDT window */
}

- appDidBecomeActive:sender;
- appDidInit:sender;
- appWillTerminate:sender;

- (int)getGlobalWindowNum;

- initContent:(const NXRect*)contentRect style:(int)aStyle
    	      backing:(int)bufferingType buttonMask:(int)mask defer:(BOOL)flag;

- keyDown:(NXEvent*) event;

- panVdtViewPort:sender;

- (int)selectedTag;

- setVdtBorderGray:(float)grayValue;

- setVdtPanDelta:(int)panDelta;

- setVdtWindowLevel:sender;

- windowDidBecomeKey:sender;

- windowDidBecomeMain:sender;

- windowDidResignMain:sender;

@end

