//----------------------------------------------------------------------------------------------------
//
//	DefaultSubInspector
//
//	Inherits From:		Object
//
//	Declared In:		DefaultSubInspector.h
//
//	Class Description
//
//		DefaultSubInspector provides an abstract superclass for any
//		subinspectors used by the custom WM Contents Inspector
//		WrapperInspector.
//		
//	Disclaimer
//
//		You may freely copy, distribute and reuse this software and its
//		associated documentation. I disclaim any warranty of any kind, 
//		expressed or implied, as to its fitness for any particular use.
//
//----------------------------------------------------------------------------------------------------
#import <appkit/appkit.h>


@interface DefaultSubInspector : Object
{
	id	inspectorView;
}

//----------------------------------------------------------------------------------------------------
//  Initialization and Free Methods
//----------------------------------------------------------------------------------------------------
+ new;


//----------------------------------------------------------------------------------------------------
//  Accessing Inspection View
//----------------------------------------------------------------------------------------------------
- inspectorView;
- clearInspectorView;


//----------------------------------------------------------------------------------------------------
//  Inspection Methods
//----------------------------------------------------------------------------------------------------
- inspect: (STR) path;
- inspectionError: (STR) path;


@end