#import <sys/types.h>
#import <stddef.h>
#import "CD_DBaseSubs.h"

    /* This subroutine has information for CD's with 9 tracks, and
     * which have 40 or more, but under 45 minutes of music on them.
     */

#define SNIFFN_BLUEDIV         867529478 /* key parts = 2409.60.09.278 300 */
#define MOODY_EVERYGOODBOY     868561484 /* key parts = 2412.50.09.284 380 */
#define APP_AMMONIAAVE         868633354 /* key parts = 2412.65.09.304 393 */
#define MIKENMECH_MECHANICS    870803025 /* key parts = 2418.67.09.375 257 */
#define EJOHN_EMPTYSKY_POLY    883345408 /* key parts = 2453.55.09.508 418 */
#define MOLDFIELD_EARTHMOVING  895095878 /* key parts = 2486.28.09.278 520 */
#define DIREST_DIRESTRAITS     895811041 /* key parts = 2488.27.09.241 294 */
#define LEDZEP_II_STUDBOX      896377384 /* key parts = 2489.70.09.334 259 */
#define EJOHN_EMPTYSKY_MCA     900059015 /* key parts = 2500.12.09.515 420 */
#define TDREAM_LEPARC_SEQ      901705374 /* key parts = 2504.55.09.324 372 */
#define CALL_INTOTHEWOODS      905194967 /* key parts = 2514.32.09.317 299 */
#define BJOEL_NYLONCURTAIN     906347032 /* key parts = 2517.47.09.232 199 */
#define APP_STEREO             907403088 /* key parts = 2520.42.09.438 81 */
#define MOODY_OTHERSIDE        910417491 /* key parts = 2528.70.09.291 294 */
#define JJACKSON_NIGHTNDAY     911425440 /* key parts = 2531.55.09.240 423 */
#define PBARDENS_WATERCOLORS   914266960 /* key parts = 2539.47.09.310 255 */
#define VAR_T_MOONREVISITED    915155036 /* key parts = 2542.07.09.236 121 */
#define CFRANKE_B5             923967838 /* key parts = 2566.43.09.238 347 */
#define DIREST_COMMUN          924073376 /* key parts = 2566.65.09.326 351 */
#define PINKF_DSOTM_UK         928345437 /* key parts = 2578.55.09.237 126 */
#define PINKF_DSOTM_20th       928691040 /* key parts = 2579.52.09.240 124 */
#define EAGLES_1OFNIGHTS       929075090 /* key parts = 2580.57.09.290 223 */
#define BDYLAN_SAVED           929401468 /* key parts = 2581.50.09.118 281 */
#define BSPRING_RIVER_D2       940369416 /* key parts = 2612.10.09.366 235 */
#define EAGLES_HOTELCAL        940921442 /* key parts = 2613.50.09.392 448 */
#define WHO_WHOSNEXT_UMD       942673351 /* key parts = 2618.40.09.301 515 */
#define LEDZEP_PHYD2_STUDBOX   943715027 /* key parts = 2621.32.09.527 283 */
#define LEDZEP_PHYD2           945985430 /* key parts = 2627.55.09.530 283 */
#define EJOHN_ROCKWESTIES_MCA  947651026 /* key parts = 2632.27.09.376 265 */
#define EAGLES_HOTELCAL_DCC    952739045 /* key parts = 2646.37.09.395 451 */
#define SUPERT_FREEASABIRD     955441351 /* key parts = 2654.00.09.301 468 */
#define PBARDENS_FURTHER       964153366 /* key parts = 2678.15.09.316 391 */
#define JBECK_BLOWBYBLOW       965195046 /* key parts = 2681.07.09.246 506 */
#define LEDZEP_I_STUDBOX       969106966 /* key parts = 2691.72.09.166 507 */


void filltoc09_40(tocPtr, cdKey)
struct cd_toc *tocPtr;
u_int cdKey;
{

    if ( cdKey == APP_AMMONIAAVE ) { /* 0:40:12-65 */
	tocPtr->discPerformer = "Alan Parsons Project";
	tocPtr->discTitle = "Ammonia Avenue";
#     if !defined(SKIPSONGS_Alan_Parsons_Project)
	SET_CDtt( 1, 05.04, "Prime Time");
	SET_CDtt( 2, 03.21, "Let Me Go Home");
	SET_CDtt( 3, 03.37, "One Good Reason");
	SET_CDtt( 4, 04.35, "Since The Last Goodbye");
	SET_CDtt( 5, 04.13, "Don't Answer Me");
	SET_CDtt( 6, 04.23, "Dancing On A Highwire");
	SET_CDtt( 7, 04.27, "You Don't Believe");
	SET_CDtt( 8, 03.57, "Pipeline");
	SET_CDtt( 9, 06.33, "Ammonia Avenue");
#     endif
	}
    if ( cdKey == APP_STEREO ) { /* 0:42:00-42 */
	tocPtr->discPerformer = "Alan Parsons Project";
	tocPtr->discTitle = "Stereotomy";
#     if !defined(SKIPSONGS_Alan_Parsons_Project)
	SET_CDtt( 1, 07.18, "Stereotomy");
	SET_CDtt( 2, 04.27, "Beaujolais");
	SET_CDtt( 3, 05.00, "Urbania  [instrumental]");
	SET_CDtt( 4, 04.39, "Limelight");
	SET_CDtt( 5, 04.20, "In The Real World");
	SET_CDtt( 6, 07.32, "Where's The Walrus?  [instrumental]");
	SET_CDtt( 7, 06.20, "Light Of The World");
	SET_CDtt( 8, 01.01, "Chinese Whispers  [instrumental]");
	SET_CDtt( 9, 01.21, "Stereotomy Two");
#     endif
	}
    if ( cdKey == PBARDENS_WATERCOLORS ) { /* 0:42:19-47 */
	tocPtr->discPerformer = "Pete Bardens";
	tocPtr->discTitle = "Water Colors";
	SET_CDtt( 1, 05.10, "Journey");
	SET_CDtt( 2, 05.01, "De Profundis");
	SET_CDtt( 3, 04.56, "A Higher Ground");
	SET_CDtt( 4, 04.04, "Yellowstone Blue");
	SET_CDtt( 5, 04.42, "Is It Any Wonder");
	SET_CDtt( 6, 04.25, "Water Colors");
	SET_CDtt( 7, 05.03, "Shape of the Rain");
	SET_CDtt( 8, 04.41, "Timepiece");
	SET_CDtt( 9, 04.15, "Ghostwater");
	}
    if ( cdKey == PBARDENS_FURTHER ) { /* 0:44:38-15 */
	tocPtr->discPerformer = "Pete Bardens";
	tocPtr->discTitle = "Further Than You Know";
	SET_CDtt( 1, 05.16, "Sometime");
	SET_CDtt( 2, 04.14, "Dream Catcher");
	SET_CDtt( 3, 03.31, "Sea of Dreams");
	SET_CDtt( 4, 05.13, "Real Time");
	SET_CDtt( 5, 05.26, "Coco Loco");
	SET_CDtt( 6, 05.12, "Further Than You Know");
	SET_CDtt( 7, 05.16, "Bad Boy (Redemption Song)");
	SET_CDtt( 8, 03.57, "This Could Be Like Heaven");
	SET_CDtt( 9, 06.31, "Rain Talk");
	}
    if ( cdKey == JBECK_BLOWBYBLOW ) { /* 0:44:41-07 */
	tocPtr->discPerformer = "Jeff Beck";
	tocPtr->discTitle = "Blow by Blow";
#     if !defined(SKIPSONGS_Jeff_Beck)
	SET_CDtt( 1, 04.06, "You Know What I Mean");
	SET_CDtt( 2, 04.31, "She's a Woman");
	SET_CDtt( 3, 02.48, "Constipated Duck");
	SET_CDtt( 4, 05.10, "AIR Blower");
	SET_CDtt( 5, 05.41, "Scatterbrain");
	SET_CDtt( 6, 05.42, "Cause We've Ended as Lovers");
	SET_CDtt( 7, 03.17, "Thelonius");
	SET_CDtt( 8, 04.58, "Freeway Jam");
	SET_CDtt( 9, 08.26, "Diamond Dust");
#     endif
	}
    if ( cdKey == CALL_INTOTHEWOODS ) { /* 0:41:54-32 */
	tocPtr->discPerformer = "The Call";
	tocPtr->discTitle = "Into the Woods";
	tocPtr->discCatNum = "007559607392900";
#     if !defined(SKIPSONGS_The_Call)
	SET_CDtt( 1, 05.17, "I Don't Wanna");
	SET_CDtt( 2, 04.03, "In The River");
	SET_CDtt( 3, 04.39, "It Could Have Been Me");
	SET_CDtt( 4, 05.12, "The Woods");
	SET_CDtt( 5, 04.15, "Day Or Night");
	SET_CDtt( 6, 04.07, "Memory");
	SET_CDtt( 7, 04.26, "Too Many Tears");
	SET_CDtt( 8, 04.54, "Expecting");
	SET_CDtt( 9, 04.59, "Walk Walk");
#     endif
	}
    if ( cdKey == DIREST_DIRESTRAITS ) { /* 0:41:28-27 */
	tocPtr->discPerformer = "Dire Straits";
	tocPtr->discTitle = "Dire Straits";
	tocPtr->discCatNum = "325918000512200";
#     if !defined(SKIPSONGS_Dire_Straits)
	SET_CDtt( 1, 04.01, "Southbound Again");
	SET_CDtt( 2, 05.24, "Sultans of Swing");
	SET_CDtt( 3, 03.20, "In the Gallery");
	SET_CDtt( 4, 04.11, "Wild West End");
	SET_CDtt( 5, 02.59, "Lions");
	SET_CDtt( 6, 05.36, "Down to the Waterline");
	SET_CDtt( 7, 06.16, "Water of Love");
	SET_CDtt( 8, 04.45, "Setting Me Up");
	SET_CDtt( 9, 04.54, "Six Blade Knife");
#     endif
	}
    if ( cdKey == DIREST_COMMUN ) { /* 0:42:46-65 */
	tocPtr->discPerformer = "Dire Straits";
	tocPtr->discTitle = "Communiqu";
	tocPtr->discCatNum = "007599033302500";
#     if !defined(SKIPSONGS_Dire_Straits)
	SET_CDtt( 1, 05.26, "Once Upon a Time in the West");
	SET_CDtt( 2, 04.13, "News");
	SET_CDtt( 3, 03.51, "Where Do You Think You're Going?");
	SET_CDtt( 4, 05.50, "Communiqu");
	SET_CDtt( 5, 03.46, "Lady Writer");
	SET_CDtt( 6, 04.36, "Angel of Mercy");
	SET_CDtt( 7, 04.30, "Portobello Belle");
	SET_CDtt( 8, 04.41, "Singlehanded Sailor");
	SET_CDtt( 9, 05.51, "Follow Me Home");
#     endif
	}
    if ( cdKey == BDYLAN_SAVED ) { /* 0:43:01-50 */
	tocPtr->discPerformer = "Bob Dylan";
	tocPtr->discTitle = "Saved";
#     if !defined(SKIPSONGS_Bob_Dylan)
	SET_CDtt( 1, 01.58, "A Satisfied Mind");
	SET_CDtt( 2, 04.03, "Saved");
	SET_CDtt( 3, 06.06, "Covenant Woman");
	SET_CDtt( 4, 05.55, "What Can I Do For You?");
	SET_CDtt( 5, 03.58, "Solid Rock");
	SET_CDtt( 6, 05.14, "Pressing On");
	SET_CDtt( 7, 06.00, "In The Garden");
	SET_CDtt( 8, 05.04, "Saving Grace");
	SET_CDtt( 9, 04.41, "Are You Ready");
#     endif
	}
    if ( cdKey == EAGLES_1OFNIGHTS ) { /* 0:43:00-57 */
	tocPtr->discPerformer = "Eagles";
	tocPtr->discTitle = "One of These Nights";
	tocPtr->discCatNum = "007559530142900";
#     if !defined(SKIPSONGS_Eagles)
	SET_CDtt( 1, 04.50, "One Of These Nights");
	SET_CDtt( 2, 04.41, "Too Many Hands");
	SET_CDtt( 3, 04.01, "Hollywood Waltz");
	SET_CDtt( 4, 06.40, "Journey of the Sorcerer");
	SET_CDtt( 5, 06.21, "Lyin' Eyes");
	SET_CDtt( 6, 04.47, "Take It To The Limit");
	SET_CDtt( 7, 03.58, "Visions");
	SET_CDtt( 8, 03.57, "After The Thrill Is Gone");
	SET_CDtt( 9, 03.43, "I Wish You Peace");
#     endif
	}
    if ( cdKey == EAGLES_HOTELCAL ) { /* 0:43:33-50 */
	tocPtr->discPerformer = "Eagles";
	tocPtr->discTitle = "Hotel California";
	tocPtr->discCatNum = "007559001032600";
#     if !defined(SKIPSONGS_Eagles)
	SET_CDtt( 1, 06.32, "Hotel California");
	SET_CDtt( 2, 05.05, "New Kid In Town");
	SET_CDtt( 3, 04.47, "Life In The Fast Lane");
	SET_CDtt( 4, 04.55, "Wasted Time");
	SET_CDtt( 5, 01.24, "Wasted Time (reprise)");
	SET_CDtt( 6, 04.09, "Victim Of Love");
	SET_CDtt( 7, 04.00, "Pretty Maids All In A Row");
	SET_CDtt( 8, 05.11, "Try And Love Again");
	SET_CDtt( 9, 07.28, "The Last Resort");
#     endif
	}
    if ( cdKey == EAGLES_HOTELCAL_DCC ) { /* 0:44:06-37 */
	tocPtr->discPerformer = "Eagles";
	tocPtr->discTitle = "Hotel California  [DCC Gold]";
#     if !defined(SKIPSONGS_Eagles)
	SET_CDtt( 1, 06.35, "Hotel California");
	SET_CDtt( 2, 05.05, "New Kid In Town");
	SET_CDtt( 3, 04.49, "Life In The Fast Lane");
	SET_CDtt( 4, 05.01, "Wasted Time");
	SET_CDtt( 5, 01.26, "Wasted Time (reprise)");
	SET_CDtt( 6, 04.10, "Victim Of Love");
	SET_CDtt( 7, 04.11, "Pretty Maids All In A Row");
	SET_CDtt( 8, 05.16, "Try And Love Again");
	SET_CDtt( 9, 07.31, "The Last Resort");
#     endif
	}
    if ( cdKey == CFRANKE_B5 ) { /* 0:42:46-43 */
	tocPtr->discPerformer = "Christopher Franke";
	tocPtr->discTitle = "Babylon 5";
	SET_CDtt( 1, 03.58, "Chrysalis - Part 1");
	SET_CDtt( 2, 04.45, "Chrysalis - Part 2");
	SET_CDtt( 3, 05.51, "Chrysalis - Part 3");
	SET_CDtt( 4, 03.49, "Chrysalis - Part 4");
	SET_CDtt( 5, 03.38, "Mindwar - Part 1");
	SET_CDtt( 6, 02.39, "Mindwar - Part 2");
	SET_CDtt( 7, 06.12, "Parliament of Dreams - Part 1");
	SET_CDtt( 8, 06.05, "Parliament of Dreams - Part 2");
	SET_CDtt( 9, 05.47, "Parliament of Dreams - Part 3");
	}
    if ( cdKey == JJACKSON_NIGHTNDAY ) { /* 0:42:11-55 */
	tocPtr->discPerformer = "Joe Jackson";
	tocPtr->discTitle = "Night and Day";
	SET_CDtt( 1, 04.00, "Another World");
	SET_CDtt( 2, 04.07, "Chinatown");
	SET_CDtt( 3, 03.43, "T.V. Age");
	SET_CDtt( 4, 03.46, "Target");
	SET_CDtt( 5, 04.28, "Steppin' Out");
	SET_CDtt( 6, 04.53, "Breaking Us in Two");
	SET_CDtt( 7, 06.04, "Cancer");
	SET_CDtt( 8, 04.05, "Real Men");
	SET_CDtt( 9, 07.03, "A Slow Song");
	}
    if ( cdKey == BJOEL_NYLONCURTAIN ) { /* 0:41:57-47 */
	tocPtr->discPerformer = "Billy Joel";
	tocPtr->discTitle = "The Nylon Curtain";
	SET_CDtt( 1, 03.52, "Allentown");
	SET_CDtt( 2, 05.06, "Laura");
	SET_CDtt( 3, 04.43, "Pressure");
	SET_CDtt( 4, 07.06, "Goodnight Saigon");
	SET_CDtt( 5, 04.15, "She's Right On Time");
	SET_CDtt( 6, 04.05, "A Room of Our Own");
	SET_CDtt( 7, 03.29, "Surprises");
	SET_CDtt( 8, 06.00, "Scandinavian Skies");
	SET_CDtt( 9, 03.19, "Where's The Orchestra?");
	}
    if ( cdKey == EJOHN_EMPTYSKY_MCA ) { /* 0:41:40-12 */
	tocPtr->discPerformer = "Elton John";
	tocPtr->discTitle = "Empty Sky  [MCA]";
#     if !defined(SKIPSONGS_Elton_John)
	SET_CDtt( 1, 08.35, "Empty Sky");
	SET_CDtt( 2, 04.15, "ValHala");
	SET_CDtt( 3, 03.19, "Western Ford Gateway");
	SET_CDtt( 4, 04.34, "Hymn 2000");
	SET_CDtt( 5, 03.12, "Lady What's Tomorrow");
	SET_CDtt( 6, 03.46, "Sails");
	SET_CDtt( 7, 03.18, "The Scaffold");
	SET_CDtt( 8, 03.39, "Skyline Pigeon");
	SET_CDtt( 9, 07.00, "Gulliver/ Hay Chewed");
#     endif
	}
    if ( cdKey == EJOHN_EMPTYSKY_POLY ) { /* 0:40:53-55 */
	tocPtr->discPerformer = "Elton John";
	tocPtr->discTitle = "Empty Sky  [Polydor]";
#     if !defined(SKIPSONGS_Elton_John)
	SET_CDtt( 1, 08.28, "Empty Sky");
	SET_CDtt( 2, 04.09, "ValHala");
	SET_CDtt( 3, 03.14, "Western Ford Gateway");
	SET_CDtt( 4, 04.27, "Hymn 2000");
	SET_CDtt( 5, 03.09, "Lady What's Tomorrow");
	SET_CDtt( 6, 03.39, "Sails");
	SET_CDtt( 7, 03.14, "The Scaffold");
	SET_CDtt( 8, 03.33, "Skyline Pigeon");
	SET_CDtt( 9, 06.58, "Gulliver/ Hay Chewed/ Reprise");
#     endif
	}
    if ( cdKey == EJOHN_ROCKWESTIES_MCA ) { /* 0:43:52-27 */
	tocPtr->discPerformer = "Elton John";
	tocPtr->discTitle = "Rock of the Westies  [MCA]";
#     if !defined(SKIPSONGS_Elton_John)
	SET_CDtt( 1, 06.16, "Medley (Yell Help, Wednesday Night, Ugly)");
	SET_CDtt( 2, 03.30, "Dan Dare (Pilot of the Future)");
	SET_CDtt( 3, 03.42, "Island Girl");
	SET_CDtt( 4, 04.46, "Grow Some Funk of Your Own");
	SET_CDtt( 5, 05.31, "I Feel Like a Bullet (In the Gun of Robert Ford)");
	SET_CDtt( 6, 06.23, "Street Kids");
	SET_CDtt( 7, 05.16, "Hard Luck Story");
	SET_CDtt( 8, 04.01, "Feed Me");
	SET_CDtt( 9, 04.25, "Billy Bones and the White Bird");
#     endif
	}
    if ( cdKey == LEDZEP_I_STUDBOX ) { /* 0:44:51-72 */
	tocPtr->discPerformer = "Led Zeppelin";
	tocPtr->discTitle = "I  [studio box]";
	tocPtr->discCatNum = "007567825262400";
#     if !defined(SKIPSONGS_Led_Zeppelin)
	SET_CDtt( 1, 02.46, "Good Times, Bad Times");
	SET_CDtt( 2, 06.41, "Babe I'm Gonna Leave You");
	SET_CDtt( 3, 06.28, "You Shook Me");
	SET_CDtt( 4, 06.26, "Dazed and Confused");
	SET_CDtt( 5, 04.35, "Your Time Is Gonna Come");
	SET_CDtt( 6, 02.13, "Black Mountain Side");
	SET_CDtt( 7, 02.30, "Communication Breakdown");
	SET_CDtt( 8, 04.43, "I Can't Quit You Baby");
	SET_CDtt( 9, 08.27, "How Many More Times");
#     endif
	}
    if ( cdKey == LEDZEP_II_STUDBOX ) { /* 0:41:29-70 */
	tocPtr->discPerformer = "Led Zeppelin";
	tocPtr->discTitle = "II  [studio box]";
	tocPtr->discCatNum = "007567825262400";
#     if !defined(SKIPSONGS_Led_Zeppelin)
	SET_CDtt( 1, 05.34, "Whole Lotta Love");
	SET_CDtt( 2, 04.46, "What Is And What Should Never Be");
	SET_CDtt( 3, 06.20, "The Lemon Song");
	SET_CDtt( 4, 04.49, "Thank You");
	SET_CDtt( 5, 04.14, "Heartbreaker");
	SET_CDtt( 6, 02.40, "Living Loving Maid (She's Just a Woman)");
	SET_CDtt( 7, 04.24, "Ramble On");
	SET_CDtt( 8, 04.21, "Moby Dick");
	SET_CDtt( 9, 04.19, "Bring It On Home");
#     endif
	}
    if ( cdKey == LEDZEP_PHYD2 ) { /* 0:43:47-55 */
	tocPtr->discPerformer = "Led Zeppelin";
	tocPtr->discTitle = "Physical Graffiti  [disc 2]";
	tocPtr->discCatNum = "007567002002300";
#     if !defined(SKIPSONGS_Led_Zeppelin)
	SET_CDtt( 1, 08.50, "In The Light");
	SET_CDtt( 2, 02.06, "BronYrAur");
	SET_CDtt( 3, 05.17, "Down By the Seaside");
	SET_CDtt( 4, 06.35, "Ten Years Gone");
	SET_CDtt( 5, 03.38, "Night Flight");
	SET_CDtt( 6, 04.09, "The Wanton Song");
	SET_CDtt( 7, 03.53, "Boogie With Stu");
	SET_CDtt( 8, 04.33, "Black Country Woman");
	SET_CDtt( 9, 04.43, "Sick Again");
#     endif
	}
    if ( cdKey == LEDZEP_PHYD2_STUDBOX ) { /* 0:43:41-32 */
	tocPtr->discPerformer = "Led Zeppelin";
	tocPtr->discTitle = "Physical Graffiti  [disc 2] [studio box]";
	tocPtr->discCatNum = "007567825262400";
#     if !defined(SKIPSONGS_Led_Zeppelin)
	SET_CDtt( 1, 08.47, "In The Light");
	SET_CDtt( 2, 02.06, "BronYrAur");
	SET_CDtt( 3, 05.16, "Down By the Seaside");
	SET_CDtt( 4, 06.33, "Ten Years Gone");
	SET_CDtt( 5, 03.38, "Night Flight");
	SET_CDtt( 6, 04.10, "The Wanton Song");
	SET_CDtt( 7, 03.53, "Boogie With Stu");
	SET_CDtt( 8, 04.33, "Black Country Woman");
	SET_CDtt( 9, 04.43, "Sick Again");
#     endif
	}
    if ( cdKey == MIKENMECH_MECHANICS ) { /* 0:40:18-67 */
	tocPtr->discPerformer = "Mike + The Mechanics";
	tocPtr->discTitle = "Mike + The Mechanics";
	tocPtr->discCatNum = "007567812872100";
	SET_CDtt( 1, 06.15, "Silent Running");
	SET_CDtt( 2, 04.10, "All I Need is a Miracle");
	SET_CDtt( 3, 03.36, "Par Avion");
	SET_CDtt( 4, 04.41, "Hanging By a Thread");
	SET_CDtt( 5, 04.31, "I Get the Feeling");
	SET_CDtt( 6, 04.18, "Take the Reins");
	SET_CDtt( 7, 03.46, "You Are the One");
	SET_CDtt( 8, 04.42, "A Call to Arms");
	SET_CDtt( 9, 04.17, "Taken In");
	}
    if ( cdKey == MOODY_EVERYGOODBOY ) { /* 0:40:12-50 */
	tocPtr->discPerformer = "Moody Blues";
	tocPtr->discTitle = "Every Good Boy Deserves Favor";
	tocPtr->discCatNum = "004228201602700";
#     if !defined(SKIPSONGS_Moody_Blues)
	SET_CDtt( 1, 04.44, "Procession");
	SET_CDtt( 2, 02.56, "The Story In Your Eyes");
	SET_CDtt( 3, 03.35, "Our Guessing Game");
	SET_CDtt( 4, 03.42, "Emily's Song");
	SET_CDtt( 5, 04.33, "After You Came");
	SET_CDtt( 6, 05.42, "One More Time To Live");
	SET_CDtt( 7, 04.23, "Nice To Be Here");
	SET_CDtt( 8, 04.15, "You Can Never Go Home");
	SET_CDtt( 9, 06.20, "My Song");
#     endif
	}
    if ( cdKey == MOODY_OTHERSIDE ) { /* 0:42:08-70 */
	tocPtr->discPerformer = "Moody Blues";
	tocPtr->discTitle = "The Other Side of Life";
	tocPtr->discCatNum = "004228291792800";
#     if !defined(SKIPSONGS_Moody_Blues)
	SET_CDtt( 1, 04.51, "Your Wildest Dreams");
	SET_CDtt( 2, 03.56, "Talkin' Talkin'");
	SET_CDtt( 3, 04.51, "Rock 'n' Roll Over You");
	SET_CDtt( 4, 03.29, "I Just Don't Care");
	SET_CDtt( 5, 04.24, "Running Out Love");
	SET_CDtt( 6, 06.52, "The Other Side Of Life");
	SET_CDtt( 7, 04.19, "The Spirit");
	SET_CDtt( 8, 04.30, "Slings and Arrows");
	SET_CDtt( 9, 04.54, "It May Be A Fire");
#     endif
	}
    if ( cdKey == MOLDFIELD_EARTHMOVING ) { /* 0:41:26-28 */
	tocPtr->discPerformer = "Mike OldField";
	tocPtr->discTitle = "Earth Moving";
#     if !defined(SKIPSONGS_Mike_Oldfield)
	SET_CDtt( 1, 04.38, "Holy");
	SET_CDtt( 2, 04.10, "Hostage");
	SET_CDtt( 3, 04.25, "Far Country");
	SET_CDtt( 4, 03.31, "Innocent");
	SET_CDtt( 5, 04.07, "Runaway Son");
	SET_CDtt( 6, 04.00, "See The Light");
	SET_CDtt( 7, 04.04, "Earth Moving");
	SET_CDtt( 8, 03.49, "Blue Night");
	SET_CDtt( 9, 08.40, "Nothing But/ Bridge To Paradise");
#     endif
	}
    if ( cdKey == PINKF_DSOTM_UK ) { /* 0:42:58-55 */
	tocPtr->discPerformer = "Pink Floyd";
	tocPtr->discTitle = "Dark Side of the Moon  [UK version]";
#     if !defined(SKIPSONGS_Pink_Floyd)
	SET_CDtt( 1, 03.57, "Speak to Me/ Breathe in the Air");
	SET_CDtt( 2, 03.32, "On the Run");
	SET_CDtt( 3, 07.05, "Time");
	SET_CDtt( 4, 04.47, "The Great Gig in the Sky");
	SET_CDtt( 5, 06.24, "Money");
	SET_CDtt( 6, 07.49, "Us and Them");
	SET_CDtt( 7, 03.25, "Any Colour You Like");
	SET_CDtt( 8, 03.51, "Brain Damage");
	SET_CDtt( 9, 02.06, "Eclipse");
#     endif
	}
    if ( cdKey == PINKF_DSOTM_20th ) { /* 0:42:59-52 */
	tocPtr->discPerformer = "Pink Floyd";
	tocPtr->discTitle = "Dark Side of the Moon  [remastered or 20th Anniversary Edition]";
	tocPtr->discCatNum = "007777814792300";
#     if !defined(SKIPSONGS_Pink_Floyd)
	SET_CDtt( 1, 04.00, "Speak to Me/ Breathe in the Air");
	SET_CDtt( 2, 03.33, "On the Run");
	SET_CDtt( 3, 07.07, "Time");
	SET_CDtt( 4, 04.44, "The Great Gig in the Sky");
	SET_CDtt( 5, 06.32, "Money");
	SET_CDtt( 6, 07.41, "Us and Them");
	SET_CDtt( 7, 03.25, "Any Colour You Like");
	SET_CDtt( 8, 03.51, "Brain Damage");
	SET_CDtt( 9, 02.04, "Eclipse");
#     endif
	}
    if ( cdKey == SNIFFN_BLUEDIV ) { /* 0:40:09-60 */
	tocPtr->discPerformer = "Sniff 'n' the Tears";
	tocPtr->discTitle = "Ride Blue Divide";
	tocPtr->discCatNum = "004228238302000";
	SET_CDtt( 1, 04.38, "The Hand Of Fate");
	SET_CDtt( 2, 03.33, "Hungry Eyes");
	SET_CDtt( 3, 05.17, "Company Man");
	SET_CDtt( 4, 03.42, "Roll The Weight Away");
	SET_CDtt( 5, 03.20, "Like Wildfire");
	SET_CDtt( 6, 04.50, "Trouble Is My Business");
	SET_CDtt( 7, 05.13, "You May Find Your Heart");
	SET_CDtt( 8, 04.34, "Gold");
	SET_CDtt( 9, 05.00, "Ride Blue Divide");
	}
    if ( cdKey == BSPRING_RIVER_D2 ) { /* 0:43:32-10 */
	tocPtr->discPerformer = "Bruce Springsteen";
	tocPtr->discTitle = "The River  [disc 2]";
#     if !defined(SKIPSONGS_Bruce_Springsteen)
	SET_CDtt( 1, 06.06, "Point Blank");
	SET_CDtt( 2, 03.03, "Cadillac Ranch");
	SET_CDtt( 3, 03.37, "I'm A Rocker");
	SET_CDtt( 4, 04.46, "Fade Away");
	SET_CDtt( 5, 03.54, "Stolen Car");
	SET_CDtt( 6, 04.06, "Ramrod");
	SET_CDtt( 7, 05.30, "The Price You Pay");
	SET_CDtt( 8, 08.33, "Drive All Night");
	SET_CDtt( 9, 03.55, "Wreck on the Highway");
#     endif
	}
    if ( cdKey == SUPERT_FREEASABIRD ) { /* 0:44:14-00 */
	tocPtr->discPerformer = "Supertramp";
	tocPtr->discTitle = "Free as a Bird";
	SET_CDtt( 1, 05.01, "It's Alright");
	SET_CDtt( 2, 04.37, "Not the Moment");
	SET_CDtt( 3, 04.53, "It Doesn't Matter");
	SET_CDtt( 4, 03.41, "Where I Stand");
	SET_CDtt( 5, 04.23, "Free as a Bird");
	SET_CDtt( 6, 05.31, "I'm Beggin' You");
	SET_CDtt( 7, 04.18, "You Never Can Tell With Friends");
	SET_CDtt( 8, 04.00, "Thing For You");
	SET_CDtt( 9, 07.48, "An Awful Thing to Waste");
	}
    if ( cdKey == TDREAM_LEPARC_SEQ ) { /* 0:41:44-55 */
	tocPtr->discPerformer = "Tangerine Dream";
	tocPtr->discTitle = "Le Parc  [sequel]";
#     if !defined(SKIPSONGS_Tangerine_Dream)
	SET_CDtt( 1, 05.24, "Bois de Boulogne (Paris)");
	SET_CDtt( 2, 03.42, "Central Park (New York)");
	SET_CDtt( 3, 05.14, "Gaudi Par (Guell Garden Barcelona)");
	SET_CDtt( 4, 03.11, "Tiergarten (Berlin)");
	SET_CDtt( 5, 04.52, "Zen Garden (Ryoanji Temple Kyoto)");
	SET_CDtt( 6, 03.21, "Le Parc (L.A. - Streethawk)");
	SET_CDtt( 7, 04.01, "Hyde Park (London)");
	SET_CDtt( 8, 05.45, "The Cliffs of Sydney (Sydney)");
	SET_CDtt( 9, 06.12, "Yellowstone Park (Rocky Mountains)");
#     endif
	}
    if ( cdKey == VAR_T_MOONREVISITED ) { /* 0:42:22-07 */
	tocPtr->discPerformer = "Various Artists/ Tributes";
	tocPtr->discTitle = "The Moon Revisited";
	SET_CDtt( 1, 03.56, "Speak To Me/ Breathe  [Cairo]");
	SET_CDtt( 2, 03.38, "On the Run  [Rob LaVaque]");
	SET_CDtt( 3, 07.10, "Time  [Shadow Gallery]");
	SET_CDtt( 4, 04.39, "The Great Gig in the Sky  [Dark Side of the Moon]");
	SET_CDtt( 5, 07.13, "Money  [Magellan]");
	SET_CDtt( 6, 07.44, "Us and Them  [Enchant]");
	SET_CDtt( 7, 03.28, "Any Colour You Like  [World Trade]");
	SET_CDtt( 8, 02.31, "Brain Damage  [Robert Berry]");
	SET_CDtt( 9, 02.01, "Eclipse  [various...]");
	}
    if ( cdKey == WHO_WHOSNEXT_UMD ) { /* 0:43:38-40 */
	tocPtr->discPerformer = "The Who";
	tocPtr->discTitle = "Who's Next  [Ultimate MasterDisc]";
	SET_CDtt( 1, 05.01, "Baba O'Riley");
	SET_CDtt( 2, 05.35, "Bargain");
	SET_CDtt( 3, 02.11, "Love Ain't for Keeping");
	SET_CDtt( 4, 03.36, "My Wife");
	SET_CDtt( 5, 06.20, "The Song is Over");
	SET_CDtt( 6, 04.50, "Gettin' In Tune");
	SET_CDtt( 7, 03.45, "Goin' Mobile");
	SET_CDtt( 8, 03.43, "Behind Blue Eyes");
	SET_CDtt( 9, 08.35, "Won't Get Fooled Again");
	}
}


