#import <sys/types.h>
#import <stddef.h>
#import "CD_DBaseSubs.h"

    /* This subroutine has information for CD's with 10 tracks, and
     * which have 50 or more minutes of music on them.
     */

#define BENATAR_WIDEAWAKE     1093561622 /* key parts = 3037.50.10.272 298 */
#define SPINDOC_KRYPT         1097075228 /* key parts = 3047.32.10.278 763 */
#define PCM_RHYTHMNBYTES      1099071938 /* key parts = 3052.73.10.338 292 */
#define MOODY_SERLAMER        1105369598 /* key parts = 3070.35.10.398 411 */
#define PINKF_MLOR_SO         1106560013 /* key parts = 3073.58.10.263 527 */
#define PINKF_MLOR            1107707214 /* key parts = 3076.72.10.264 528 */
#define U2_ZOOROPA            1109363192 /* key parts = 3081.42.10.392 341 */
#define TTIKARAM_LOVERSINCITY 1126273586 /* key parts = 3128.40.10.236 425 */
#define LON_YES_SYMPH         1188903970 /* key parts = 3302.38.10.370 436 */
#define TDREAM_TANGENTS_D5    1211848034 /* key parts = 3366.18.10.284 338 */
#define CAMEL_NEVERLETGO_D1   1283665642 /* key parts = 3565.55.10.442 253 */
#define PWARD_FEAROFMAKEBLV   1378331224 /* key parts = 3828.52.10.574 311 */
#define TDREAM_TANGENTS_D1    1398875112 /* key parts = 3885.57.10.462 217 */
#define LEDZEP_BOX1_D3        1552235163 /* key parts = 4311.57.10.513 665 */


void filltoc10_50(tocPtr, cdKey)
struct cd_toc *tocPtr;
u_int cdKey;
{

    if ( cdKey == BENATAR_WIDEAWAKE ) { /* 0:50:37-50 */
	tocPtr->discPerformer = "Pat Benatar";
	tocPtr->discTitle = "Wide Awake in Dreamland";
#     if !defined(SKIPSONGS_Pat_Benatar)
	SET_CDtt( 1, 04.32, "All Fired Up");
	SET_CDtt( 2, 05.14, "One Love");
	SET_CDtt( 3, 04.58, "Let's Stay Together");
	SET_CDtt( 4, 04.41, "Don't Walk Away");
	SET_CDtt( 5, 06.42, "Too Long A Soldier");
	SET_CDtt( 6, 05.30, "Cool Zero");
	SET_CDtt( 7, 04.47, "Cerebral Man");
	SET_CDtt( 8, 05.00, "Lift 'em On Up");
	SET_CDtt( 9, 04.13, "Suffer The Little Children");
	SET_CDtt(10, 04.58, "Wide Awake in Dreamland");
#     endif
	}
    if ( cdKey == CAMEL_NEVERLETGO_D1 ) { /* 0:59:25-55 */
	tocPtr->discPerformer = "Camel";
	tocPtr->discTitle = "Never Let Go  [disc 1]";
#     if !defined(SKIPSONGS_Camel)
	SET_CDtt( 1, 07.22, "Never Let Go");
	SET_CDtt( 2, 08.02, "Earthrise");
	SET_CDtt( 3, 02.24, "Rhayader");
	SET_CDtt( 4, 05.14, "Rhayader Goes to Town");
	SET_CDtt( 5, 03.03, "Spirit of the Water");
	SET_CDtt( 6, 05.45, "Unevensong");
	SET_CDtt( 7, 07.48, "Echoes");
	SET_CDtt( 8, 10.21, "Ice");
	SET_CDtt( 9, 05.11, "City Life");
	SET_CDtt(10, 04.13, "Drafted");
#     endif
	}
    if ( cdKey == LEDZEP_BOX1_D3 ) { /* 1:11:51-57 */
	tocPtr->discPerformer = "Led Zeppelin";
	tocPtr->discTitle = "Led Zeppelin [disc 3]";
	tocPtr->discCatNum = "007567821442400";
#     if !defined(SKIPSONGS_Led_Zeppelin)
	SET_CDtt( 1, 08.33, "Kashmir");
	SET_CDtt( 2, 05.35, "Trampled Under Foot");
	SET_CDtt( 3, 06.21, "For Your Life");
	SET_CDtt( 4, 07.01, "No Quarter");
	SET_CDtt( 5, 03.43, "Dancing Days");
	SET_CDtt( 6, 07.07, "When The Levee Breaks");
	SET_CDtt( 7, 10.23, "Achilles Last Stand");
	SET_CDtt( 8, 05.29, "The Song Remains The Same");
	SET_CDtt( 9, 06.32, "Ten Years Gone");
	SET_CDtt(10, 11.05, "In My Time of Dying");
#     endif
	}
    if ( cdKey == LON_YES_SYMPH ) { /* 0:55:02-38 */
	tocPtr->discPerformer = "London Symphony Orchestra";
	tocPtr->discTitle = "Symphonic Music of Yes";
#     if !defined(SKIPSONGS_Yes)
	SET_CDtt( 1, 06.10, "Roundabout");
	SET_CDtt( 2, 07.40, "Close to the Edge");
	SET_CDtt( 3, 03.54, "Wonderous Stories");
	SET_CDtt( 4, 03.50, "I've Seen All Good People");
	SET_CDtt( 5, 03.02, "Mood for a Day");
	SET_CDtt( 6, 04.44, "Owner of a Lonely Heart");
	SET_CDtt( 7, 04.17, "Survival");
	SET_CDtt( 8, 07.50, "Heart of the Sunrise");
	SET_CDtt( 9, 06.17, "Soon");
	SET_CDtt(10, 07.16, "Starship Trooper");
#     endif
	}
    if ( cdKey == MOODY_SERLAMER ) { /* 0:51:10-35 */
	tocPtr->discPerformer = "Moody Blues";
	tocPtr->discTitle = "Sur La Mer";
#     if !defined(SKIPSONGS_Moody_Blues)
	SET_CDtt( 1, 06.38, "I Know You're Out There Somewhere");
	SET_CDtt( 2, 04.49, "Want To Be With You");
	SET_CDtt( 3, 04.46, "River Of Endless Love");
	SET_CDtt( 4, 05.15, "No More Lies");
	SET_CDtt( 5, 04.16, "Here Comes the Weekend");
	SET_CDtt( 6, 03.38, "Vintage Wine");
	SET_CDtt( 7, 04.55, "Breaking Point");
	SET_CDtt( 8, 04.58, "Miracle");
	SET_CDtt( 9, 05.02, "Love Is On The Run");
	SET_CDtt(10, 06.51, "Deep");
#     endif
	}
    if ( cdKey == PCM_RHYTHMNBYTES ) { /* 0:50:52-73 */
	tocPtr->discPerformer = "P.C.M.";
	tocPtr->discTitle = "Rhythm and Bytes";
	SET_CDtt( 1, 05.38, "Computermusic Part I");
	SET_CDtt( 2, 05.21, "Computermusic Part II");
	SET_CDtt( 3, 05.49, "Miditime");
	SET_CDtt( 4, 04.40, "Happy Computer");
	SET_CDtt( 5, 09.06, "Datastream SRC-2");
	SET_CDtt( 6, 04.06, "Bits and Bytes");
	SET_CDtt( 7, 03.35, "High Voltage");
	SET_CDtt( 8, 04.37, "Puls Code Modulation 1630");
	SET_CDtt( 9, 03.06, "Data Dump");
	SET_CDtt(10, 04.52, "Rhythm and Bytes");
	}
    if ( cdKey == PINKF_MLOR ) { /* 0:51:16-72 */
	tocPtr->discPerformer = "Pink Floyd";
	tocPtr->discTitle = "A Momentary Lapse of Reason";
#     if !defined(SKIPSONGS_Pink_Floyd)
	SET_CDtt( 1, 04.24, "Signs of Life");
	SET_CDtt( 2, 04.54, "Learning to Fly");
	SET_CDtt( 3, 06.10, "The Dogs of War");
	SET_CDtt( 4, 05.05, "One Slip");
	SET_CDtt( 5, 05.42, "On The Turning Away");
	SET_CDtt( 6, 07.28, "Yet Another Movie / Round and Round");
	SET_CDtt( 7, 01.47, "A New Machine - Part 1");
	SET_CDtt( 8, 06.17, "Terminal Frost");
	SET_CDtt( 9, 00.39, "A New Machine - Part 2");
	SET_CDtt(10, 08.48, "Sorrow");
#     endif
	}
    if ( cdKey == PINKF_MLOR_SO ) { /* 0:51:13-58 */
	tocPtr->discPerformer = "Pink Floyd";
	tocPtr->discTitle = "A Momentary Lapse of Reason  [Shine On box]";
#     if !defined(SKIPSONGS_Pink_Floyd)
	SET_CDtt( 1, 04.23, "Signs of Life");
	SET_CDtt( 2, 04.53, "Learning to Fly");
	SET_CDtt( 3, 06.09, "The Dogs of War");
	SET_CDtt( 4, 05.07, "One Slip");
	SET_CDtt( 5, 05.42, "On The Turning Away");
	SET_CDtt( 6, 07.28, "Yet Another Movie / Round and Round");
	SET_CDtt( 7, 01.46, "A New Machine - Part 1");
	SET_CDtt( 8, 06.17, "Terminal Frost");
	SET_CDtt( 9, 00.39, "A New Machine - Part 2");
	SET_CDtt(10, 08.47, "Sorrow");
#     endif
	}
    if ( cdKey == SPINDOC_KRYPT ) { /* 0:50:47-32 */
	tocPtr->discPerformer = "Spin Doctors";
	tocPtr->discTitle = "Pocket Full of Kryptonite";
	SET_CDtt( 1, 04.38, "Jimmy Olsen's Blues");
	SET_CDtt( 2, 04.51, "What Time is It?");
	SET_CDtt( 3, 03.55, "Little Miss Can't Be Wrong");
	SET_CDtt( 4, 04.23, "Forty or Fifty");
	SET_CDtt( 5, 04.46, "Refrigerator Car");
	SET_CDtt( 6, 02.13, "More than She Knows");
	SET_CDtt( 7, 04.18, "Two Princes");
	SET_CDtt( 8, 03.59, "Off My Line");
	SET_CDtt( 9, 04.59, "How Could You Want Him (When You Know You Could Have Me?)");
	SET_CDtt(10, 12.43, "Shinbone Alley / Hard to Exist");
	}
    if ( cdKey == TDREAM_TANGENTS_D1 ) { /* 1:04:45-57 */
	tocPtr->discPerformer = "Tangerine Dream";
	tocPtr->discTitle = "Tangents  [disc 1]";
#     if !defined(SKIPSONGS_Tangerine_Dream)
	SET_CDtt( 1, 07.42, "Mohave Plan  [Desert part]");
	SET_CDtt( 2, 07.32, "No Man's Land");
	SET_CDtt( 3, 04.57, "Kiew Mission");
	SET_CDtt( 4, 07.14, "Ricochet");
	SET_CDtt( 5, 05.34, "Force Majeure");
	SET_CDtt( 6, 05.58, "Logos  [Blue part]");
	SET_CDtt( 7, 10.45, "Stratosfear");
	SET_CDtt( 8, 07.08, "Mysterious Semblance");
	SET_CDtt( 9, 04.16, "Cinnamon Road");
	SET_CDtt(10, 03.37, "Tangram  [Solution part]");
#     endif
	}
    if ( cdKey == TDREAM_TANGENTS_D5 ) { /* 0:56:06-18 */
	tocPtr->discPerformer = "Tangerine Dream";
	tocPtr->discTitle = "Tangents  [disc 5]";
#     if !defined(SKIPSONGS_Tangerine_Dream)
	SET_CDtt( 1, 04.44, "Vulcano");
	SET_CDtt( 2, 04.00, "The Jogger");
	SET_CDtt( 3, 03.25, "South Dakota");
	SET_CDtt( 4, 05.19, "Coppercoast");
	SET_CDtt( 5, 03.59, "Great Barrier Reef");
	SET_CDtt( 6, 03.20, "The Night at Ayers Rock");
	SET_CDtt( 7, 06.55, "Afternoon on the Nile");
	SET_CDtt( 8, 05.56, "Crane Routing");
	SET_CDtt( 9, 12.48, "Silver Scale");
	SET_CDtt(10, 05.38, "Jamaican Monk");
#     endif
	}
    if ( cdKey == TTIKARAM_LOVERSINCITY ) { /* 0:52:08-40 */
	tocPtr->discPerformer = "Tanita Tikaram";
	tocPtr->discTitle = "Lovers in the City";
	SET_CDtt( 1, 03.56, "I Might Be Crying");
	SET_CDtt( 2, 04.13, "Bloodlines");
	SET_CDtt( 3, 05.16, "Feeding the Witches");
	SET_CDtt( 4, 05.42, "Happy Taxi");
	SET_CDtt( 5, 04.36, "My Love Tonight");
	SET_CDtt( 6, 06.23, "Lovers in the City");
	SET_CDtt( 7, 03.35, "Yodelling Song");
	SET_CDtt( 8, 06.11, "Wonderful Shadow");
	SET_CDtt( 9, 05.09, "Women Who Cheat on the World");
	SET_CDtt(10, 07.05, "Leaving the Party");
	}
    if ( cdKey == U2_ZOOROPA ) { /* 0:51:21-42 */
	tocPtr->discPerformer = "U2";
	tocPtr->discTitle = "Zooropa";
	/* cd has Track ISRC numbers (on a NeXT CD-ROM) of:
	        1 = x'5D 24 51 78 93 00 01 80 00 00 00 00 00 00 00'
	   thru
	       10 = x'5D 24 51 78 93 00 02 70 00 00 00 00 00 00 00'
	*/
#     if !defined(SKIPSONGS_U2)
	SET_CDtt( 1, 06.32, "Zooropa");
	SET_CDtt( 2, 04.01, "Babyface");
	SET_CDtt( 3, 04.21, "Numb");
	SET_CDtt( 4, 06.58, "Lemon");
	SET_CDtt( 5, 04.58, "Stay (Faraway, So Close)");
	SET_CDtt( 6, 05.20, "Daddy's Gonna Pay for Your Crashed Car");
	SET_CDtt( 7, 04.18, "Some Days Are Better Than Others");
	SET_CDtt( 8, 03.45, "The First Time");
	SET_CDtt( 9, 05.25, "Dirty Day");
	SET_CDtt(10, 05.41, "The Wanderer");
#     endif
	}
    if ( cdKey == PWARD_FEAROFMAKEBLV ) { /* 1:03:48-52 */
	tocPtr->discPerformer = "Paul Ward";
	tocPtr->discTitle = "The Fear of Make-Believe";
	SET_CDtt( 1, 09.34, "Waiting for a Miracle");
	SET_CDtt( 2, 06.59, "Taken to a Place");
	SET_CDtt( 3, 06.19, "Bloody Dangerous");
	SET_CDtt( 4, 04.25, "Time, the Magician");
	SET_CDtt( 5, 04.31, "Death by Wireless");
	SET_CDtt( 6, 05.17, "64K World");
	SET_CDtt( 7, 06.53, "Iceman");
	SET_CDtt( 8, 07.19, "Overnight Snow");
	SET_CDtt( 9, 07.18, "Closer than You Think");
	SET_CDtt(10, 05.11, "Silly Kind of Secret");
	}
}
